%%OVERRIDE
% presDOF = [5,6,7];
% 
% FEM.K = cBlocks(1).polygon(1).K;
% 
% FEM.K(presDOF,      :) = zeros;
% FEM.K(:      ,presDOF) = zeros;
% FEM.K(presDOF,presDOF) = eye(size(presDOF,2));
% 
% FEM.K = full(FEM.K);
% 
% FEM.F(presDOF,      :) = zeros;
% 
% return

for i = 1:1:size(BC,2)
    setType = BC(i).set{1};
    switch setType
        case 'domain'
            %evaluate at all active domain transition blocks from typeArray
            checkBlocks = find(typeArray(:,1)==2);
            
            %find those blocks associated with current set
                %evaluate set signed distance function
                switch domain(BC(i).set{2}).type{1}
                    case 'ellipse'
                        sdGrid = sdCircle(points,domain(BC(i).set{2}).edges);
                        sdGrid = reshape(sdGrid,qt.size+1,qt.size+1);
                    otherwise; disp('case not implemented yet')
                end
                
                %evaluate each checkBlock to see if part of domain
                isBCBlock = zeros(size(checkBlocks,1),1);
                for j = 1:1:size(checkBlocks,1)
                    upperEdge = qtActive(checkBlocks(j),pos);%do not have to adjust position by -1 since sd array starts from 1 in indexing
                    cNodes = [upperEdge;...
                              upperEdge + [                             0,qtActive(checkBlocks(j),width)];...
                              upperEdge + [qtActive(checkBlocks(j),width),qtActive(checkBlocks(j),width)];...
                              upperEdge + [qtActive(checkBlocks(j),width),                            0]];
                    %check domain
                    isBCBlock(j,1) = checkBCBlock(cNodes,sdGrid);
                end
                isBCBlock = find(isBCBlock>1);
            
            polyInd = checkBlocks(isBCBlock);
            
            %find special case where at least on node touches the boundary, be the remaining are inside the domain (technically a transition element, however just a special boundary case)
            specialCase = find(polyInd==0);
            
            BCDOF = [];
            for j = 1:1:size(polyInd,1)
                for k = 1:1:size(cBlocks(polyInd(j)).polygon,2)
                    %intersection nodes
                    iNodes = cBlocks(polyInd(j)).polygon(k).intPoints ;
                    nodes  = cBlocks(polyInd(j)).polygon(k).nodes;
                    %find intersection nodes in nodes matrix
                    [~, ind]=ismember(iNodes,nodes,'rows');
                    %find corresponding position in gId vector
                    globalId = cBlocks(polyInd(j)).polygon(k).gID;
                    globalId = globalId(ind)';
                    globalId = oldInd(globalId);
                    %switch these DOF to nodes
                    globalDOF = nodesToDOF(globalId,FEM.DOFPerNode);
                    %add to BCDOF vector
                    BCDOF = [BCDOF,globalDOF];
                end
            end  
            BCDOF = uniquetol(BCDOF);
        case 'set'
            switch BC(i).set{2}
                case 'bottom'
                    %find bottom nodes
                        tempN = find(abs(globalNodes(:,2)-min(globalNodes(:,2)))<FEM.tol);
                        if length(BC(i).set)==3
                            %range
                                lower = abs(globalNodes(tempN,1)>=BC(i).set{3}(1));
                                upper = abs(globalNodes(tempN,1)<=BC(i).set{3}(2));
                            %update
                                tempN = tempN( lower & upper );
                        end
                    %find their respective DOF
                        BCDOF = nodesToDOF(tempN,FEM.DOFPerNode);                       
                case 'top'
                    %find top node indices
                        tempN = find(abs(globalNodes(:,2)-max(globalNodes(:,2)))<FEM.tol);
                        if length(BC(i).set)==3
                            %range
                                lower = abs(globalNodes(tempN,1)>=BC(i).set{3}(1));
                                upper = abs(globalNodes(tempN,1)<=BC(i).set{3}(2));
                            %update
                                tempN = tempN( lower & upper );
                        end
                    %find their respective DOF
                        BCDOF = nodesToDOF(tempN,FEM.DOFPerNode);
                case 'points'
                    if isnumeric(BC(i).set{3})
                        %find nodes closest to specified input
                        %disp('explicit BC points found')
                        dist = pdist2(BC(i).set{3}, globalNodes, 'euclidean');
                        mindist = min(dist,[],2);
                        [~,col] = find(dist==mindist);
                    %find their respective DOF
                        BCDOF = nodesToDOF(col,FEM.DOFPerNode);    
                    end
            end
        otherwise; disp('other set type cases for BCs not implemented yet')
    end
    
    %Apply BC
        %filter DOF based on axes
        if BC(i).coord == [1,0]
            oddIndices = rem(BCDOF, 2) == 1;
            BCDOF = BCDOF(oddIndices);
        end
        if BC(i).coord == [0,1]
            evenIndices = rem(BCDOF, 2) == 0;
            BCDOF = BCDOF(evenIndices);
        end
        %determine assignment indices
        presDOF = BCDOF;
        freeDOF = 1:FEM.nDOF;
        freeDOF = setdiff(freeDOF,presDOF);
        
        uPres = zeros(size(BCDOF,2),1);
        if BC(i).value(1,1) ~= 0
            oddIndices = rem(BCDOF, 2) == 1;
            uPres(oddIndices) = BC(i).value(1,1);
        end
        if BC(i).value(1,2) ~= 0
            evenIndices = rem(BCDOF, 2) == 0;
            uPres(evenIndices) = BC(i).value(1,2); 
        end
        if sum(BC(i).value) ~= 0
            FEM.F(freeDOF,1) = FEM.F(freeDOF,1)-FEM.K(freeDOF,presDOF)*uPres;
            FEM.F(presDOF,1) = uPres;
        else
            FEM.F(presDOF,1) = uPres;
        end

        FEM.K(presDOF,      :) = zeros;
        FEM.K(:      ,presDOF) = zeros;
        FEM.K(presDOF,presDOF) = eye(size(presDOF,2));
        
end

















