%%  Determine the approximate neighbours of each active block inside a group (aprroximate, because only finds one neighbour per side)
    for i = 1:1:qt.nGroups
        %find blocks in group domain given by qtActive
        groupBlocks = find(typeArray(:,2+i)==1);
        group(i).levelDiff = zeros(length(groupBlocks),4);
        %determine level of neighbours at all four sides ofeach block via seedquadrant search
        for j = 1:1:length(groupBlocks)
            %retrieve all position points and offset to obtain center points
            cPoints = qtActive(groupBlocks(j),pos)+(qtActive(groupBlocks(j),width)-1)/2;
            %ofset in four neighbour drections
            offset  = [0,1,-1,0,0,-1,1,0] .* qtActive(groupBlocks(j),width);
            cPoints = repmat(cPoints,1,4) + offset;
            cPoints = reshape(cPoints', 2, [])';
            %no points to discard because all domain blocks neighboured by transition block
            nVec = zeros(1,4);
            for k = 1:1:size(cPoints,1)
                nInd = 1;
                while (qtArray(nInd,active)~=1)
                    %function "seedQuadrant" unrolled
                    cx = (qtArray(nInd,width)-1)/2+qtArray(nInd,pos(1));
                    cy = (qtArray(nInd,width)-1)/2+qtArray(nInd,pos(2));
                    a = atan2(cPoints(k,2)-cy(1),cPoints(k,1)-cx(1));
                    if ( a>    0 && a<=   pi/2); quadrant = 1;end; if ( a> pi/2 && a<=   pi  ); quadrant = 2;end; if ( a>-pi   && a<=  -pi/2); quadrant = 3;end; if ( a>-pi/2 && a<=      0); quadrant = 4;end
                    nInd = qtArray(nInd,kids(quadrant));
                end
                nVec(1,k) = qtArray(nInd,level); %gain approximate neighbour by replacing with "nInd"
            end
            group(i).levelDiff(j,:) = nVec;
            blockLevel = qtActive(groupBlocks(j),level);
            group(i).levelDiff(j,:) = group(i).levelDiff(j,:) - blockLevel;
        end
        group(i).levelDiff(group(i).levelDiff>0) = 1;
        group(i).levelDiff(group(i).levelDiff<1) = 0;
        group(i).groupBlocks = groupBlocks;
    end

%%  Determine block type via library portion
    for i =  1:1:qt.nGroups
        group(i).blockType = zeros(size(group(i).levelDiff,1),1);
        for j = 1:1:size(group(i).groupBlocks,1)
            group(i).hangingNodes(j,1) = sum(group(i).levelDiff(j,:),2);
            switch group(i).hangingNodes(j,1)
                case 0; blockType =  1; %no side nodes      --> orientation agnostic
                case 4; blockType = 16; %all side nodes     --> orientation agnostic
                case 1 %one side node
                    tempInd = find(group(i).levelDiff(j,:));
                    switch tempInd
                        case 1; blockType =  4;
                        case 2; blockType =  5;
                        case 3; blockType =  2;
                        case 4; blockType =  3;
                    end

                case 2 %two side nodes
                    tempInd = find(group(i).levelDiff(j,:));
                    if tempInd == [1,2]; blockType =  8; end
                    if tempInd == [2,3]; blockType =  9; end
                    if tempInd == [3,4]; blockType =  6; end
                    if tempInd == [1,4]; blockType =  7; end
                    if tempInd == [1,3]; blockType = 10; end
                    if tempInd == [2,4]; blockType = 11; end
                    
                case 3 %three side nodes
                    tempInd = find(group(i).levelDiff(j,:)==0);
                    switch tempInd
                        case 1; blockType =  15;
                        case 2; blockType =  12;
                        case 3; blockType =  13;
                        case 4; blockType =  14;
                    end
            end
        group(i).blockType(j,1) = blockType;   
        end
    end

%%  Clean up
    clear i j k cx cy a blockLevel blockType cNodes cPoints nInd nVec offset quadrant tempInd