function isConvex = checkConvex(px,py)

numPoints = size(px,1);
if numPoints < 4
    isConvex = 1;
    return
end

v1 = [px(1) - px(end), py(1) - py(end)];
v2 = [px(2) - px(1  ), py(2) - py(1  )];
sign1 = sign(det([v1; v2]));

for k = 2:numPoints-1
    v1 = v2;
    v2 = [px(k+1) - px(k), py(k+1) - py(k)]; 
    sign2 = sign(det([v1; v2]));
    if sign1 * sign2 < 0
        isConvex = 0;
        return
    end
    sign1 = sign2;
end

v1 = v2;
v2 = [px(1) - px(end), py(1) - py(end)];
sign2 = sign(det([v1; v2]));
if sign1 * sign2 < 0
    isConvex = 0;
else
    isConvex = 1;
end