function [class] = checkCrack(cNodes,qt,it,FEM,crack)
    %evaluate signed distance function at these points
    sdEvalLine  = zeros(1,size(cNodes,1));
    sdEvalRange = zeros(1,size(cNodes,1));
    for i = 1:1:size(cNodes,1)
        sdEvalLine (1,i) = qt.crack{it}.line( cNodes(i,2),cNodes(i,1));
        sdEvalRange(1,i) = qt.crack{it}.range(cNodes(i,2),cNodes(i,1));
    end
    nodeOnLine = find(abs(sdEvalLine)<FEM.tol);
    sdEvalLine  = find(sdEvalLine <0);
    sdEvalRange = find(sdEvalRange<0);
    
    %partition based on if any positive values are present
    testLine  = size(sdEvalLine ,2);
    testRange = size(sdEvalRange,2);
    
    switch testLine
        case {0,size(cNodes,1)}; if nodeOnLine; crackLine = 1; else; crackLine = 0; end %not cracked, possible touched
        otherwise;  crackLine = 1; %on crack line
    end
    switch testRange
        case size(cNodes,1); crackRange = 1; %in range of crack
        case              0; crackRange = 0; %not in range of crack
        otherwise;  crackRange = 2; %crack tip
    end
    
    if testLine && ~testRange
        x1 = crack(it).points(:,1);
        y1 = crack(it).points(:,2);
        x2 = cNodes(:,1);
        y2 = cNodes(:,2);
        in = inpolygon(x1,y1,x2',y2');
        if any(in)
            crackRange = 2;
        end
    end
    
    if crackLine && crackRange
        if crackRange == 1
            class = 1; %cracked block
        else
            class = 2; %crack tip blocks
        end
    else
        class = 0; % not cracked
    end
end