%%  find active blocks first
    activeId = find(qtArray(1:qt.nDecomp,active)>0);
    qtActive = qtArray(activeId,:);
    qt.nActive = size(activeId,1);
    
%%  Refine polygon of explicit points
    %calculate .seeds for each domain and features (cracks are handled seperately later)
    for i = 1:1:qt.nDomains
        switch domain(i).type{1}
            case 'polyline'
                tempPoly = [domain(i).edges;domain(i).edges(1,:)];
                for j = 1:1:size(tempPoly,1)-1
                    xS = tempPoly(j  ,1);
                    xE = tempPoly(j+1,1);
                    yS = tempPoly(j  ,2);
                    yE = tempPoly(j+1,2);
                    distance = sqrt((xE-xS)^2+(yE-yS)^2);
                    domain(i).seeds(j) = ceil(distance)/qt.decompMin;
                end
            case 'ellipse'
                domain(i).seeds = ceil(2*pi*domain(i).edges(2,1))/qt.decompMin;
            otherwise; disp('case not implemented yet')
        end
    end
    
    for i = 1:1:qt.nFeatures
        switch feature(i).type{1}
            case 'polyline'
                tempPoly = [feature(i).edges;feature(i).edges(1,:)];
                for j = 1:1:size(tempPoly,1)-1
                    xS = tempPoly(j  ,1);
                    xE = tempPoly(j+1,1);
                    yS = tempPoly(j  ,2);
                    yE = tempPoly(j+1,2);
                    distance = sqrt((xE-xS)^2+(yE-yS)^2);
                    feature(i).seeds(j) = ceil(distance)/qt.decompMin;
                end
            case 'ellipse'
                feature(i).seeds = ceil(2*pi*feature(i).edges(2,1))/qt.decompMin;
            otherwise; disp('case not implemented yet')
        end
    end
    
%%  Perform polygon clipping based on current seeds to obtain at least one point in every polygon
    clipGroups

%%  Determine transition blocks
    tempInd = zeros(qt.nPoints,1);
    for i = 1:1:qt.nPoints
        bInd = 1;
        while (qtArray(bInd,active)~=1)
            %function "seedQuadrant" unrolled
            cx = (qtArray(bInd,width)-1)/2+qtArray(bInd,pos(1));
            cy = (qtArray(bInd,width)-1)/2+qtArray(bInd,pos(2));
            a = atan2(qt.pointsExp(i,2)-cy(1),qt.pointsExp(i,1)-cx(1));
            if ( a>    0 && a<=   pi/2); quadrant = 1;end; if ( a> pi/2 && a<=   pi  ); quadrant = 2;end; if ( a>-pi   && a<=  -pi/2); quadrant = 3;end; if ( a>-pi/2 && a<=      0); quadrant = 4;end
                bInd = qtArray(bInd,kids(quadrant));
        end
        tempInd(i) = bInd;
    end
    tInd = uniquetol(tempInd);
    
testInd = find(qtArray(:,nSeeds)>0);
    
    
return
%%  OLD CODE
    
    %initialize block array
    cBlocks(qt.nActive).group = -1;
    cBlocks(qt.nActive).crack = -1;
    cBlocks(qt.nActive).levelDiff = -1;
    cBlocks(qt.nActive).blockType = -1;
    
%%  Determine approxmative neighbours for each block
    for i = 1:1:qt.nActive
        %retrieve all position points and offset to obtain center points
        cPoints = qtActive(i,pos)+(qtActive(i,width)-1)/2;
        %ofset in four neighbour drections
        offset  = [0,1,-1,0,0,-1,1,0] .* qtActive(i,width);
        cPoints = repmat(cPoints,1,4) + offset;
        cPoints = reshape(cPoints', 2, [])';
        %discard cPoints outside of domain limits
        cPoints = cPoints((cPoints(:,1)>=0 & cPoints(:,1)<= qt.size),:);
        cPoints = cPoints((cPoints(:,2)>=0 & cPoints(:,2)<= qt.size),:);
        %initialize neighbour vector
        nVec = zeros(1,4);
        for k = 1:1:size(cPoints,1)
            nInd = 1;
            while (qtArray(nInd,active)~=1)
                %function "seedQuadrant" unrolled
                cx = (qtArray(nInd,width)-1)/2+qtArray(nInd,pos(1));
                cy = (qtArray(nInd,width)-1)/2+qtArray(nInd,pos(2));
                a = atan2(cPoints(k,2)-cy(1),cPoints(k,1)-cx(1));
                if ( a>    0 && a<=   pi/2); quadrant = 1;end; if ( a> pi/2 && a<=   pi  ); quadrant = 2;end; if ( a>-pi   && a<=  -pi/2); quadrant = 3;end; if ( a>-pi/2 && a<=      0); quadrant = 4;end
                    nInd = qtArray(nInd,kids(quadrant));
            end
            nVec(1,k) = qtArray(nInd,level); %gain approximate neighbour by replacing with "nInd"
        end
        blockLevel = qtActive(i,level);
        cBlocks(i).levelDiff = nVec - blockLevel;
        cBlocks(i).levelDiff(cBlocks(i).levelDiff>0) = 1;
        cBlocks(i).levelDiff(cBlocks(i).levelDiff<1) = 0;
    end
    
%%  Determine blockType and assign nodes to each block
    for  i =1:1:qt.nActive
        nIntNodes = sum(cBlocks(i).levelDiff);
        switch nIntNodes
            case 0; blockType =  1; cBlocks(i).nodes = [1,1;0,1;0,0;1,0];
            case 4; blockType = 16; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0.5;0,0;0.5,0;1,0;1,0.5];
            case 1 %one side node
                tempInd = find(cBlocks(i).levelDiff);
                switch tempInd
                    case 1; blockType =  4; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0;1,0];
                    case 2; blockType =  5; cBlocks(i).nodes = [1,1;0,1;0,0.5;0,0;1,0];
                    case 3; blockType =  2; cBlocks(i).nodes = [1,1;0,1;0,0;0.5,0;1,0];
                    case 4; blockType =  3; cBlocks(i).nodes = [1,1;0,1;0,0;1,0;1,0.5];
                end

            case 2 %two side nodes
                tempInd = find(cBlocks(i).levelDiff);
                if tempInd == [1,2]; blockType =  8; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0.5;0,0;1,0];end
                if tempInd == [2,3]; blockType =  9; cBlocks(i).nodes = [1,1;0,1;0,0.5;0,0;0.5,0;1,0];end
                if tempInd == [3,4]; blockType =  6; cBlocks(i).nodes = [1,1;0,1;0,0;0.5,0;1,0;1,0.5];end
                if tempInd == [1,4]; blockType =  7; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0;1,0;1,0.5];end
                if tempInd == [1,3]; blockType = 10; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0;0.5,0;1,0];end
                if tempInd == [2,4]; blockType = 11; cBlocks(i).nodes = [1,1;0,1;0,0.5;0,0;1,0;1,0.5];end

            case 3 %three side nodes
                tempInd = find(cBlocks(i).levelDiff==0);
                switch tempInd
                    case 1; blockType =  15; cBlocks(i).nodes = [1,1;0,1;0,0.5;0,0;0.5,0;1,0;1,0.5];
                    case 2; blockType =  12; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0;0.5,0;1,0;1,0.5];
                    case 3; blockType =  13; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0.5;0,0;1,0;1,0.5];
                    case 4; blockType =  14; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0.5;0,0;0.5,0;1,0];
                end
        end
        cBlocks(i).blockType = blockType;
        %scale nodes
        cBlocks(i).nodes = cBlocks(i).nodes*qtActive(i,width);
        %shift nodes
        cBlocks(i).nodes(:,1) = cBlocks(i).nodes(:,1) + qtActive(i,pos(1)) - 1;
        cBlocks(i).nodes(:,2) = cBlocks(i).nodes(:,2) + qtActive(i,pos(2)) - 1;
        %close polygon
        cBlocks(i).nodes = [cBlocks(i).nodes;cBlocks(i).nodes(1,:)];
    end
    
%%  Determine if block is inside domain
    xv = groups(1).polygon(:,1);
    yv = groups(1).polygon(:,1);
    for i = 1:1:qt.nActive
        xq = cBlocks(i).nodes(:,1);
        yq = cBlocks(i).nodes(:,2);
        [in,on] = inpoly([xq,yq],[xv,yv]);
    end

%%  Determine if group polygon intersects block polygon
return
%%  Clip cBlocks polygons against all groups
    %rotate all groups by i.e. 45 deg
    t = 45;
    R = [cosd(t), -sind(t); sind(t), cosd(t)];
    for i = 1:1:qt.nGroups
        xB = groups(i).polygon(:,1);
        yB = groups(i).polygon(:,2);
        rP = R*([xB';yB']);
        groups(i).polygon = [rP(1,:)',rP(2,:)'];
    end
    
    %rotate and clip each active block
    for i = 1:1:qt.nActive
        %rotate block polygon
            xB = cBlocks(i).nodes(:,1);
            yB = cBlocks(i).nodes(:,2);
            rP = R*([xB';yB']);
        %order polygon in CW direction
        [xB,yB] = poly2cw(rP(1,:)', rP(2,:)');
        
        for j = 1:1:qt.nGroups
            disp(i)
            disp(j)
        %clip polygon
            %intersection is within domain
            [xb, yb] = polybool('intersection', groups(j).polygon(:,1), groups(j).polygon(:,2), xB, yB);
            
            %subtraction is outside of domain
            [xd, yd] = polybool('subtraction', groups(j).polygon(:,1), groups(j).polygon(:,2), xB, yB);
        end
        
    end
    
