%%  Explicit points
    %% domain
    %calc the points for each domain that is discretized
    for i = 1:1:qt.nDomains
        switch domain(i).type{1}
            case 'polyline'
                domain(i).points = subdivideSide_linear(domain(i).edges,domain(i).seeds);
            case 'ellipse'
                domain(i).points = subdivideSide_ellipse(domain(i).edges,domain(i).seeds);
            otherwise; disp('case not implemented yet')
        end
        %orient in clock-wise direction
        [domain(i).points(:,1),domain(i).points(:,2)] = poly2cw(domain(i).points(:,1),domain(i).points(:,2));
    end
    %clip polygons
    for i = 1:1:qt.nDomains
        if i == 1
            x1 = []; y1 = []; 
            %rotate + 
            t = poly.rotAngle;
            R = [cosd(t), -sind(t); sind(t), cosd(t)];
                %clipping
                rP = R*([domain(i).points(:,1)';domain(i).points(:,2)']);
                domain(i).points(:,1) = rP(1,:)'; domain(i).points(:,2) = rP(2,:)';
        else
            %rotate + 
            t = poly.rotAngle;
            R = [cosd(t), -sind(t); sind(t), cosd(t)];
                %domain
                rP = R*([x1';y1']);
                x1 = rP(1,:)'; y1 = rP(2,:)';
                %clipping
                rP = R*([domain(i).points(:,1)';domain(i).points(:,2)']);
                domain(i).points(:,1) = rP(1,:)'; domain(i).points(:,2) = rP(2,:)';
        end
        %clip polygon
        [polyX,polyY] = polybool(...
            domain(i).type{2},x1,y1,domain(i).points(:,1),domain(i).points(:,2));
        %rotate -
            t = -poly.rotAngle;
            R = [cosd(t), -sind(t); sind(t), cosd(t)];
                %domain
                rP = R*([polyX';polyY']);
                x1 = rP(1,:)'; y1 = rP(2,:)';
                %clipping
                rP = R*([domain(i).points(:,1)';domain(i).points(:,2)']);
                domain(i).points(:,1) = rP(1,:)'; domain(i).points(:,2) = rP(2,:)';
    end
    qt.domainExp = [x1,y1];

    %% feature
    for i = 1:1:qt.nFeatures
        switch feature(i).type{1}
            case 'polyline'
                feature(i).points = subdivideSide_linear(feature(i).edges,feature(i).seeds);
            case 'ellipse'
                feature(i).points = subdivideSide_ellipse(feature(i).edges,feature(i).seeds);
            otherwise; disp('case not implemented yet')
        end
        %orient in clock-wise direction
        [feature(i).points(:,1),feature(i).points(:,2)] = poly2cw(feature(i).points(:,1),feature(i).points(:,2));
    end
    featureID = [];
    for i = 1:1:qt.nFeatures
        featureID = [featureID, feature(i).type{3}];
    end
    [featureID, ~, oldInd] = uniquetol(featureID);
    for i = 1:1:length(featureID)
        qt.featureExp{i} = [];
    end
    for i = 1:1:length(featureID)
        %find indices of features pertaining to current group
        if featureID == 1
            [ind,~] = find(featureID(i)==featureID(oldInd));
        else
            [~,ind] = find(featureID(i)==featureID(oldInd));
        end
        
        for j = 1:1:length(ind)
            if j == 1; x1 = []; else; x1 = polyX(:,1); end
            if j == 1; y1 = []; else; y1 = polyY(:,1); end
            [polyX,polyY] = polybool(...
                feature(ind(j)).type{2},x1,y1,feature(ind(j)).points(:,1),feature(ind(j)).points(:,2));
        end
        qt.featureExp{i} = [polyX,polyY];
        %subtract any feature points from domain points
            %rotate + 
            t = poly.rotAngle;
            R = [cosd(t), -sind(t); sind(t), cosd(t)];
            %domain
            rP = R*([qt.domainExp(:,1)';qt.domainExp(:,2)']);
            qt.domainExp(:,1) = rP(1,:)'; qt.domainExp(:,2) = rP(2,:)';
            %feature
            rP = R*([qt.featureExp{i}(:,1)';qt.featureExp{i}(:,2)']);
            qt.featureExp{i}(:,1) = rP(1,:)'; qt.featureExp{i}(:,2) = rP(2,:)';
            
            %clip
            [polyX,polyY] = polybool(...
                    'minus',qt.domainExp(:,1),qt.domainExp(:,2),qt.featureExp{i}(:,1),qt.featureExp{i}(:,2));
            %rotate -
            t = -poly.rotAngle;
            R = [cosd(t), -sind(t); sind(t), cosd(t)];
            %domain
            rP = R*([polyX';polyY']);
            polyX = rP(1,:)'; polyY = rP(2,:)';
            %feature
            rP = R*([qt.featureExp{i}(:,1)';qt.featureExp{i}(:,2)']);
            qt.featureExp{i}(:,1) = rP(1,:)'; qt.featureExp{i}(:,2) = rP(2,:)';
                  
        qt.domainExp = [polyX,polyY];
    end
    
    %% combine all points
    
    qt.nGroups = 1 + length(featureID);
    qt.pointsExp = [];
    qt.nPoints = [];
    for i = 1:1:qt.nGroups
        if i == 1 %first group is domain group
            qt.pointsExp = [qt.pointsExp; qt.domainExp];
        else %following groups are feature groups
            qt.pointsExp = [qt.pointsExp; qt.featureExp{1,i-1}];
        end
    end
    %add crack points
    for i = 1:1:qt.nCracks
        qt.pointsExp = [qt.pointsExp;crack(i).points];
    end
    %remove NaN rows
    qt.pointsExp(any(isnan(qt.pointsExp), 2), :) = [];
    qt.pointsExp = uniquetol(qt.pointsExp,'byRows',true);
    qt.nPoints = size(qt.pointsExp,1);
    
%%  Assign points to each group
    for i = 1:1:qt.nGroups
        if i == 1
            groups(i).polygon =  qt.domainExp;
        else
            groups(i).polygon = qt.featureExp{i-1};
        end
    end