%%  find blocks touched by crack
    crackBlocks = zeros(qt.nActive,qt.nCracks);
    for i = 1:1:qt.nActive   
        for j = 1:1:qt.nCracks
            cNodes = cBlocks(i).nodes(1:end-1,:)+1;
            %check domain
            crackBlocks(i,j) = checkCrack(cNodes,qt,j,FEM,crack);
        end
        crackBlocks(crackBlocks(:,j)>0) = 1;
    end
    
%%  
    updatedBlocks = [];
    for i = 1:1:qt.nCracks
        %recall crack to insert
        x1 = crack(i).points(:,1);
        y1 = crack(i).points(:,2);
        %find all blocks which interact with a crack
        cBlockId = find(crackBlocks(:,1)==1);
        %iterate over all blocks interacting with crack
        for j = 1:1:size(cBlockId,1)
            if isempty(cBlocks(cBlockId(j)).polygon) %Block encountered
                x2 = cBlocks(cBlockId(j)).nodes(:,1);
                y2 = cBlocks(cBlockId(j)).nodes(:,2);
                [xi,yi] = polyxpoly(x1,y1,x2,y2);
                %ADD CODE TO POLYGON CASE AS WELL
                in = inpolygon(x1,y1,x2',y2');
                if ~any(in) && size(uniquetol([xi,yi],'ByRows',true),1)==1
                    %perturb node(s) on crack by FEM.tol
                    [~,LocB] = ismembertol([xi,yi],cBlocks(cBlockId(j)).nodes,'ByRows',true);
                    if LocB == 1; index = 2; else; index = LocB-1;end
                    index = index(1);
                    sdEvalPoint = qt.crack{i}.line( cBlocks(cBlockId(j)).nodes(index,2)+1,cBlocks(cBlockId(j)).nodes(index,1)+1);
                    cBlocks(cBlockId(j)).nodes(LocB,:) = cBlocks(cBlockId(j)).nodes(LocB,:)+sign(sdEvalPoint)*FEM.tol;
                    xi = []; yi = [];
                end
                a = uniquetol([xi,yi],'ByRows',true);
                if ~isempty(a);xi = a(:,1);yi = a(:,2);end
                %xi = uniquetol(xi); yi = uniquetol(yi);
                switch length(xi)
                    case 2; [cBlocks(cBlockId(j)).polygon] = splitBlockAtIntersect(FEM, qt, cBlocks, cBlockId, xi, yi, i, j); updatedBlocks = [updatedBlocks,cBlockId(j)];
                    case 1; [cBlocks(cBlockId(j)).polygon] = insertCrackTip(FEM, qt, crack, cBlocks, cBlockId, xi, yi, i, j); updatedBlocks = [updatedBlocks,cBlockId(j)];
                    case 0; %do nothing;
                end
            else
                origL = length(cBlocks(cBlockId(j)).polygon);
                pVec = zeros(1,2);
                for k = 1:1:origL %Polygon(s) encountered
                    currL = length(cBlocks(cBlockId(j)).polygon);
                    x2 = cBlocks(cBlockId(j)).polygon(k).nodes(:,1);
                    y2 = cBlocks(cBlockId(j)).polygon(k).nodes(:,2);
                    %close polygon
                    x2 = [x2;x2(1)];
                    y2 = [y2;y2(1)];
                    [xi,yi] = polyxpoly(x1,y1,x2,y2);
                    if length(xi) == 2 %implies splitting of block
                        %split block
                        polyg = splitPolyAtIntersect(FEM, qt, crack, cBlocks, cBlockId, xi, yi, i, j, k);
                        %append and delete first entry
                        for m = 1:1:length(polyg)
                            pVec(1,k) = 1;
                            cBlocks(cBlockId(j)).polygon(currL+m).nodes   = polyg(m).nodes;
                            cBlocks(cBlockId(j)).polygon(currL+m).SC      = polyg(m).SC;
                            cBlocks(cBlockId(j)).polygon(currL+m).groupId = polyg(m).groupId;
                        end
                    else %length == 1 implies crack tip present in polygon or no crack through group polygon
                        %insert crack tip element
                        
                    end
                    
                end
                cBlocks(cBlockId(j)).polygon(pVec>0) = [];
            end
        end
    end
    
%%  OVERRIDE
%cBlocks(1).polygon(1).groupId = 1;
%cBlocks(1).groupID = 1;



