%determine block indices of unique transition elements
transBlocks = []; 
for i = 1:1:qt.nGroups
        %find blocks in group domain given by qtActive
        groupBlocks = find(typeArray(:,2+i)==2);
        transBlocks = [groupBlocks;transBlocks];
end
transBlocks = uniquetol(transBlocks);

% 0. Create struct array to hold new polygons (intersection points, nodes, feature group identifier)
    %assume worst case scenario with 2 polygons per split
    sPolygons(2*size(transBlocks,1)).intPoints = -1;
    sPolygons(2*size(transBlocks,1)).nodes     = -1;
    sPolygons(2*size(transBlocks,1)).groupId   = -1;
    sPolygons(2*size(transBlocks,1)).SC        = -1;
    sPolygons(2*size(transBlocks,1)).pBlock    = -1;
    polyCounter = 1;
    
for i = 1:1:size(transBlocks,1)
    % 1. Determine if hanging nodes present on which side
        %retrieve all position points and offset to obtain center points
        %cPoints = qtActive(transBlocks(i),pos)+(qtActive(transBlocks(i),width)-1)/2
        cPoints = qtActive(transBlocks(i),pos)+qtActive(transBlocks(i),width)/2-1;
        %ofset in four neighbour drections
        offsetC  = [0,1,-1,0,0,-1,1,0] .* qtActive(transBlocks(i),width);
        cPoints = repmat(cPoints,1,4) + offsetC;
        cPoints = reshape(cPoints', 2, [])';
        %no points to discard because all domain blocks neighboured by transition block
        nVec = zeros(1,4);
        for j = 1:1:size(cPoints,1)
            nInd = 1;
            while (qtArray(nInd,active)~=1)
                %function "seedQuadrant" unrolled
                cx = (qtArray(nInd,width)-1)/2+qtArray(nInd,pos(1));
                cy = (qtArray(nInd,width)-1)/2+qtArray(nInd,pos(2));
                a = atan2(cPoints(j,2)-cy(1),cPoints(j,1)-cx(1));
                if ( a>    0 && a<=   pi/2); quadrant = 1;end; if ( a> pi/2 && a<=   pi  ); quadrant = 2;end; if ( a>-pi   && a<=  -pi/2); quadrant = 3;end; if ( a>-pi/2 && a<=      0); quadrant = 4;end
                nInd = qtArray(nInd,kids(quadrant));
            end
            nVec(1,j) = qtArray(nInd,level); %gain approximate neighbour by replacing with "nInd"
        end
        %convert hanging nodes to bollean representation (0-no, 1-yes for all four sides) by comparing levels of approx. neighbours
        blockLevel = qtActive(transBlocks(i),level);
        nVec = nVec - blockLevel;
        nVec(nVec>0) = 1; nVec(nVec<1) = 0;
        nVec = [1,nVec(1),1,nVec(2),1,nVec(3),1,nVec(4)];
        
    % 2. Evaluate signed distance functions
        %determine edge points
        cPoints = qtActive(transBlocks(i),pos)+(qtActive(transBlocks(i),width))/2-1;
        %offset in 8 directions and delete those hanging nodes, which do not occur
        offsetC = [1,1,0,1,-1,1,-1,0,-1,-1,0,-1,1,-1,1,0] .* qtActive(transBlocks(i),width)/2;
        cPoints = repmat(cPoints,1,8) + offsetC;
        cPoints = reshape(cPoints', 2, [])';
        cPoints = cPoints(nVec>0,:);
        sdVec = zeros(qt.nGroups,size(cPoints,1));
        %evaluate the signed distance functions of each group
        for j = 1:1:qt.nGroups
            for k = 1:1:size(cPoints,1)
                sdVec(j,k) = qt.featureImp{j}(cPoints(k,2)+1,cPoints(k,1)+1); %adjust as indexing starts at 1 and not 0
            end
        end

    % 3. Calculate intersection points
        intPoints = zeros(2,2); iPoint = 0;
        [row,~,~] = find(sdVec<0);
        row  = uniquetol(row);
        if row
            sdVec = [sdVec(row(1),:),sdVec(row(1),1)];  %wrap around
            cPoints = [cPoints;cPoints(1,:)];           %wrap around
            for j = 1:1:size(sdVec,2)-1
                temp = sign(sdVec(1,j))*sign(sdVec(1,j+1));
                if temp>0   %no sign change so no intersection point
                else        %sign change and thus intersection point present
                    iPoint = iPoint + 1;
                    xS = cPoints(j  ,1);
                    xE = cPoints(j+1,1);
                    dX = xE-xS;
                    yS = cPoints(j  ,2);
                    yE = cPoints(j+1,2);
                    dY = yE-yS;
                    ratio = abs(sdVec(j))/(abs(sdVec(j))+abs(sdVec(j+1)));
                    pointX = xS+dX*ratio;
                    pointY = yS+dY*ratio;
                    intPoints(iPoint,:) = [pointX,pointY];
                end
            end
        end
    
    % 4. Create polygon for each split domain
        polyPoints = [];
        for j = 1:1:size(row,1)
            if j == 1
                %negative values (first polygon)
                [~,col,~] = find(sdVec(row(1),1:end-1)<=0);
                polyPoints = [cPoints(col,:);intPoints];
            else
                %positive values (second polygon if present)
                [~,col,~] = find(sdVec(row(1),1:end-1)>=0);
                polyPoints = [cPoints(col,:);intPoints];
            end 
            polyPoints = uniquetol(polyPoints,'ByRows',true);
        % 5. Order polygon CCW 
            %find middle point of polygon
            nPolyPoints = size(polyPoints,1);
            cX = 0; cY = 0;
            for k = 1:1:nPolyPoints
                cX = cX + polyPoints(k,1);
                cY = cY + polyPoints(k,2);
            end
            cX = cX/nPolyPoints;
            cY = cY/nPolyPoints;
            a = atan2(polyPoints(:,2) - cY, polyPoints(:,1) - cX);
            [~, order] = sort(a,'ascend'); %counterclockwise
            polyPoints(:,1) = polyPoints(order,1);
            polyPoints(:,2) = polyPoints(order,2);
            
        % 6. Save polygons and group identifier
            sPolygons(polyCounter).nodes = polyPoints;
            sPolygons(polyCounter).groupId = row(j);
            sPolygons(polyCounter).SC      = [cX,cY];
            sPolygons(polyCounter).pBlock  = transBlocks(i);
            sPolygons(polyCounter).intPoints = intPoints;
            typeArray(transBlocks(i),6+j) = polyCounter;
            polyCounter = polyCounter + 1;
        end
end

% 8. Delete unused struct array space
sPolygons(polyCounter:end) = [];

qt.nPolygons = size(sPolygons,2);

%%  Clean up
    clear a blockLevel col cPoints cx cX cy cY dX dY i intPoints iPoint j k nPolyPoints nVec offsetC groupBlocks sdVec
    clear order pointX pointY polyCounter polyPoints quadrant ratio row temp tempX tempY vec xE xS yE yS midX midY nInd


