%Should be rewritten with sparse matrices
%%OVERRIDE
%FEM.F = [0,0,0,-0.05,0,-0.05,0,0.05,0,0.05,0,0]';
%return

%tailored to specific rectuagular numerical example --> will not give correct results otherwise!!!
for i = 1:1:size(Load,2)
    %determine loaded blocks and  their local elements
    setType = Load(i).set{1};
    switch setType
        case 'top'
            %find top nodes
            NodeY = qt.bBox(2,2);
            tNodes = globalNodes(abs(globalNodes(:,2)-NodeY)<FEM.tol,:);
            tNodes = tNodes(tNodes(:,1)>=Load(i).set{2}(1),:);
            tNodes = tNodes(tNodes(:,1)<=Load(i).set{2}(2),:);
            
            %it is assumed that all top elements only have one exposed side and together with the numbering convention results in:
                %element IDs = locEleId, block identifiers = blockId
                %locEleId = ones(size(blockId,1),1);
                
        case 'bottom'
            %find bottom nodes
            NodeY = qt.bBox(1,2);
            tNodes = globalNodes(abs(globalNodes(:,2)-NodeY)<FEM.tol,:);
            tNodes = tNodes(tNodes(:,1)>=Load(i).set{2}(1),:);
            tNodes = tNodes(tNodes(:,1)<=Load(i).set{2}(2),:);
            
            %it is assumed that all bottom elements only have one exposed side
                %element IDs = locEleId, block identifiers = blockId
                %locEleId = 3*ones(size(blockId,1),1);

    end
    
    [~,loc] = ismembertol(tNodes,globalNodes,'ByRows',true);
    
    %determine which blocks are attached to these nodes and unique
    blockId = [];
    for j = 1:1:qt.nActive
        id = oldInd(cBlocks(j).gID(1:end));
        if intersect(id,loc)
            blockId = [blockId,j];
        end
    end
    blockId = unique(blockId);

    %calculate force vector once and then multiply by qt.loadMagnitude
    q = Load(i).value;

    %assemble into FEM.F
    for j = 1:1:size(blockId,2)
        if isempty(cBlocks(blockId(j)).polygon)
            F_loc = qtActive(blockId(1),width) * scale * ...
                        [q,q]' ./ 2;
        else
            %find longest edge of polygon
            longestEdge = -1;
            for k = 1:1:cBlocks(blockId(j)).polygon.numberOfElements
                sX = cBlocks(blockId(j)).polygon.nodes(cBlocks(blockId(j)).polygon.localElements(k,1),1);
                eX = cBlocks(blockId(j)).polygon.nodes(cBlocks(blockId(j)).polygon.localElements(k,2),1);
                sY = cBlocks(blockId(j)).polygon.nodes(cBlocks(blockId(j)).polygon.localElements(k,1),2);
                eY = cBlocks(blockId(j)).polygon.nodes(cBlocks(blockId(j)).polygon.localElements(k,2),2);
                L = sqrt((eX-sX)^2+(eY-sY)^2);
                if L>longestEdge; longestEdge = L;end
            end
            F_loc = longestEdge * [q,q]' ./ 2;  
        end
        
        id = oldInd(cBlocks(blockId(j)).gID(1:end-1));
        switch setType
            case 'top'
                id = id(1:2);
            case 'bottom'
                id = id(3:4);
        end
        idDOF = nodesToDOF(id, FEM.DOFPerNode);
        FEM.F(idDOF) = FEM.F(idDOF) + F_loc;
    end
    
    
end















