function [qt, poly, domain, feature, crack, groups, FEM, BC, Load] = Input_File_2b()
%%  Quadtree related
    qt.decompMin            =    8;%8
    qt.decompMax            =  512;%512
    qt.size                 = 1024;
    qt.nKids                =    4;
    qt.maxSeeds             =    1;
    qt.decompDoubleBalanced =    0;
    
%%  Polygon clipping related
    poly.rotAngle = 45;
    
%%  Plotting
    qt.plotUnbalanced  = 0;
    qt.plotBalanced    = 0;
    qt.plotDomain      = 0;
    qt.plotTransition  = 0;
    qt.plotFinalMesh   = 0;
    qt.plotScaleFactor = 10;
    
%%  Domains
    domainMultiplier  = 13;

    domain(1).type  = {'polyline','plus',1};
    domain(1).edges = [0,0;100,0;100,100;0,100];
    domain(1).seeds = domainMultiplier.*[10,10,10,10];
    
%%  Features
    feature = [];
    
%%  Cracks
    crack = [];
    
%%  Material properties of each group
    groups(1).E = 100;
    groups(1).v = 0.3;
    
%%  Global FEM parameters
    FEM.nodesPerElement   = 2;  %currently the code is locked in to 2-noded elements
    FEM.quadratureType    = 1;  %Gauss = 1, Lobatto = 2
    FEM.constitutiveLaw   = 2;

    FEM.DOFPerNode = 2;
    FEM.DOFPerElement   = FEM.DOFPerNode * FEM.nodesPerElement;
    
    FEM.tol = 10^-5;
    
%%  Loading
    qt.loadMagnitude = 1;

    Load(1).set   = {'top',[23,77]};
    Load(1).value = [0,+qt.loadMagnitude];
    Load(1).distr = 'uniform';
    
    Load(2).set   = {'bottom',[23,77]};
    Load(2).value = [0,-qt.loadMagnitude];
    Load(2).distr = 'uniform';

%%  Boundary conditions
    BC(1).set   = {'set','points',[0,0]};       
    BC(1).coord = [1,0];                %enforce on x-DOF
    BC(1).value = [0,0];
    
    BC(2).set   = {'set','points',[0,0;100,0]};       
    BC(2).coord = [0,1];                %enforce on y-DOF
    BC(2).value = [0,0];   

end





















