function [qt, poly, domain, feature, crack, groups, FEM, BC, Load] = Input_File_4()
%%  "Pacman" geometry to test SIF calculations

%%  Quadtree related
    qt.decompMin            = 1024;%8
    qt.decompMax            = 1024;%512
    qt.size                 = 1024;
    qt.nKids                =    4;
    qt.maxSeeds             =    1;
    qt.decompDoubleBalanced =    0;
    
%%  Polygon clipping related
    poly.rotAngle = 45;
    
%%  Plotting
    qt.plotUnbalanced  = 0;
    qt.plotBalanced    = 0;
    qt.plotDomain      = 0;
    qt.plotTransition  = 0;
    qt.plotFinalMesh   = 0;
    qt.plotScaleFactor = 100;
    
%%  Domains
    domainMultiplier  = 1;

    domain(1).type  = {'polyline','plus',1};
    domain(1).edges = [0,0;1,0;1,1;0,1];
    domain(1).seeds = domainMultiplier.*[10,10,10,10];
    
%%  Features
    feature = [];
    
%%  Cracks
    crack(1).points = [-0.1,0.5;0.5,0.5];
    
%%  Material properties of each group
    groups(1).E = 200;
    groups(1).v = 0.25;
    
%%  Global FEM parameters
    FEM.nodesPerElement   = 2;  %currently the code is locked in to 2-noded elements
    FEM.quadratureType    = 1;  %Gauss = 1, Lobatto = 2
    FEM.constitutiveLaw   = 2;

    FEM.DOFPerNode = 2;
    FEM.DOFPerElement   = FEM.DOFPerNode * FEM.nodesPerElement;
    
    FEM.tol = 10^-5;
    
%%  Loading
    qt.loadMagnitude = 0.1;

    Load(1).set   = {'top',[0,1]};
    Load(1).value = [0,+qt.loadMagnitude];
    Load(1).distr = 'uniform';
    
    Load(2).set   = {'bottom',[0,1]};
    Load(2).value = [0,-qt.loadMagnitude];
    Load(2).distr = 'uniform';

%%  Boundary conditions
    BC(1).set   = {'set','points',[1,0]};       
    BC(1).coord = [1,1];                %enforce on y-DOF
    BC(1).value = [0,0];                %displacement of 1 IN UNSCALED UNITS!restrained against displacement
    
    BC(2).set   = {'set','points',[1,1]};       
    BC(2).coord = [1,0];                %enforce on y-DOF
    BC(2).value = [0,0];                %displacement of 1 IN UNSCALED UNITS!restrained against displacement

end





















