%%  Plot currently active blocks
    figure
    hold on
    %plot regions
    counter = 0;
    for i = 1:1:qt.nDecomp
        if (qtArray(i,active) == 1)
        sNX = qtArray(i,pos(1));
        eNX = qtArray(i,width);
        sNY = qtArray(i,pos(2));
        eNY = qtArray(i,width);
        poly = [[sNX,sNX+eNX,sNX+eNX,sNX,sNX]',[sNY,sNY,sNY+eNY,sNY+eNY,sNY]']-1;
        midX = mean(poly(:,1));
        midY = mean(poly(:,2));
        vec = [0.8,0.8,0.8]; %green
        fill(poly(:,1),poly(:,2),vec)
        text(midX,midY,num2str(i))
        end
    end
    axis equal
    xlim([0 inf])
    ylim([0 inf])
    
%%  Overlay domain and features
    [face1, vert1] = poly2fv(qt.domainExp(:,1),qt.domainExp(:,2));
    %[face2, vert2] = poly2fv(qt.featureExp{1,1}(:,1),qt.featureExp{1,1}(:,2));
    %[face3, vert3] = poly2fv(qt.featureExp{1,2}(:,1),qt.featureExp{1,2}(:,2));
    
    patch('Faces', face1, 'Vertices', vert1, 'FaceColor', 'r', ...
    'EdgeColor', 'none','FaceAlpha',0.3)
    %patch('Faces', face2, 'Vertices', vert2, 'FaceColor', 'r', ...
    %'EdgeColor', 'none','FaceAlpha',0.3)
    %patch('Faces', face3, 'Vertices', vert3, 'FaceColor', 'r', ...
    %'EdgeColor', 'none','FaceAlpha',0.3)

%%  Overlay seed points
    scatter(qt.domainExp(:,1),qt.domainExp(:,2),'+')
    %scatter(qt.featureExp{1,1}(:,1),qt.featureExp{1,1}(:,2),'+')
    %scatter(qt.featureExp{1,2}(:,1),qt.featureExp{1,2}(:,2),'+')
    
%%  Overlay crack
    %scatter(crack(1).points(:,1),crack(1).points(:,2))
    %plot(crack(1).points(:,1),crack(1).points(:,2))
    
    hold off
    
%%  Clean up
    clear -regexp ^sN ^eN ^mid ^ve ^face
    clear i