%%
hold on

for i = 1:1:qt.nActive
    if isempty(cBlocks(i).polygon)
        nodes = cBlocks(i).nodes(1:end-1,:);
        uX = cBlocks(i).U(1:2:end);
        uY = cBlocks(i).U(2:2:end);
        dispX = nodes(:,1)+qt.plotScaleFactor*uX;
        dispY = nodes(:,2)+qt.plotScaleFactor*uY;
        switch cBlocks(i).groupID
            case 1; col = 'c';
            case 2; col = 'b';
            case 3; col = 'g';
        end
        fill(dispX,dispY,col)
    else
        for j = 1:1:length(cBlocks(i).polygon)
            nodes = cBlocks(i).polygon(j).nodes;
            uX = cBlocks(i).polygon(j).U(1:2:end);
            uY = cBlocks(i).polygon(j).U(2:2:end);
            dispX = nodes(:,1)+qt.plotScaleFactor*uX;
            dispY = nodes(:,2)+qt.plotScaleFactor*uY;
            switch cBlocks(i).polygon(j).groupId
                case 1; col = 'c';
                case 2; col = 'b';
                case 3; col = 'g';
            end
            if isfield(cBlocks(i).polygon(j),'cracked')
                %add scaling center displacement
                %find rigid body translations
                lambda = diag(cBlocks(i).polygon(j).lambda);
                rigidInd = find(lambda>-0.1);
                %determine new scaling center location
                C = cBlocks(i).polygon(j).Q \ cBlocks(i).polygon(j).U;
                SCDisp = cBlocks(i).polygon(j).Q(1:FEM.DOFPerNode,rigidInd)*C(rigidInd,1);
                xFill = [dispX;cBlocks(i).polygon(j).SC(1,1)+SCDisp(1,1)*qt.plotScaleFactor];
                yFill = [dispY;cBlocks(i).polygon(j).SC(1,2)+SCDisp(2,1)*qt.plotScaleFactor];
                patch(xFill,yFill,'r')
            else
                fill(dispX,dispY,col)
            end
            
        end
    end
end
axis equal
hold off













return
%% old working routine --> do not discard
hold on

u1 = FEM.U(1:2:end);
u2 = FEM.U(2:2:end);
qt.plotScaleFactor = 100; 

for i = 1:1:qt.nActive
    if isempty(cBlocks(i).polygon)
        id = cBlocks(i).gID';
        nodes = fullNodeMatrix(id,:);
        id = oldInd(id);
        uX = u1(id);
        uY = u2(id);
        dispX = nodes(:,1)+qt.plotScaleFactor*uX;
        dispY = nodes(:,2)+qt.plotScaleFactor*uY;
        switch cBlocks(i).groupID
            case 1; col = 'c';
            case 2; col = 'b';
            case 3; col = 'g';
        end
        fill(dispX,dispY,col)
    else
        for j = 1:1:length(cBlocks(i).polygon)
            id = cBlocks(i).polygon(j).gID';
            nodes = fullNodeMatrix(id,:);
            id = oldInd(id);
            uX = u1(id);
            uY = u2(id);
            dispX = nodes(:,1)+qt.plotScaleFactor*uX;
            dispY = nodes(:,2)+qt.plotScaleFactor*uY;
            switch cBlocks(i).polygon(j).groupId
                case 1; col = 'c';
                case 2; col = 'b';
                case 3; col = 'g';
            end
            if isfield(cBlocks(i).polygon(j),'cracked')
                %add scaling center displacement
                %find rigid body translations
                rigidInd = find(cBlocks(i).polygon(j).lambda>-0.1);
                %determine new scaling center location
                id = nodesToDOF(id,FEM.DOFPerNode);
                C = cBlocks(i).polygon(j).Q \ FEM.U(id,1);
                SCDisp = cBlocks(i).polygon(j).Q(1:FEM.DOFPerNode,rigidInd)*C(rigidInd,1);
                xFill = [dispX;cBlocks(i).polygon(j).SC(1,1)+SCDisp(1,1)*qt.plotScaleFactor];
                yFill = [dispY;cBlocks(i).polygon(j).SC(1,2)+SCDisp(2,1)*qt.plotScaleFactor];
                patch(xFill,yFill,'r')
            else
                fill(dispX,dispY,col)
            end
            
        end
    end
end
axis equal
hold off