
figure
hold on

%%  Plot background for error detection
    rectangle('Position',[0,0,qt.size*scale,qt.size*scale],'FaceColor','r','EdgeColor','r')

%%  Plot all blocks
    for i = 1:1:qt.nActive
        if  isempty(cBlocks(i).polygon)
            %nodes = fullNodeMatrix(cBlocks(i).gID',:);
            nodes = cBlocks(i).nodes;
            fill(nodes(:,1),nodes(:,2),'w');
            midX = mean(nodes(:,1));
            midY = mean(nodes(:,2));
            %text(midX,midY,num2str(i))
        else
            for j = 1:1:length(cBlocks(i).polygon)
                %nodes = fullNodeMatrix(cBlocks(i).polygon(j).gID',:);
                nodes = cBlocks(i).polygon(j).nodes;
                switch cBlocks(i).polygon(j).groupId
                    case 1; col = 'b';
                    case 2; col = 'c';
                    case 3; col = 'g';
                end
                fill(nodes(:,1),nodes(:,2),col)
            end
        end
    end

%%  Plot crack polygons

%%  Scatter globalNodes to check if they were generated in the correct place
    %scatter(globalNodes(:,1),globalNodes(:,2),'m')
    
    %%  Overlay crack
    %scatter(crack(1).points(:,1)*scale,crack(1).points(:,2)*scale)
    %plot(crack(1).points(:,1)*scale,crack(1).points(:,2)*scale)
    
%%  Overlay Sensor locations
    w1 = 20.32; w2 = 284.48;
    E = 111.76; F = 80.01; G = 81.28;
    h1 = E; h2 = E+F; h3 = E+2*F; h4 = E+2*F+G; h5 = E+2*F+G+F; h6 = E+2*F+G+2*F;
    x = [w1.*ones(1,6),w2.*ones(1,6)]; y = [h1,h2,h3,h4,h5,h6,h1,h2,h3,h4,h5,h6];
    scatter(x,y,'r','filled','d')
    
%%  Overlay restraints
    scatter([101.6,203.2],[0,0],'b','filled','d')
    
%%  Finish
    axis equal
    hold off
    
%%  Clean up

