%%  Plot strain or stress depending on supplied arguments
    switch qt.plotField
        case 'stress'
            save = stressSave;
            switch qt.plotFieldType
                case 'von Mises'
                    sInd = 7;
                otherwise; disp('not implemented yet')
            end         
        otherwise; disp('not implemented yet')
    end
    
    figure
    hold on
    for i = 1:1:qt.nActive
        if isempty(cBlocks(i).polygon)
            %get x and y components of each node in block
            x = cBlocks(i).nodes(1:end-1,1);
            y = cBlocks(i).nodes(1:end-1,2);
            
            xDisp = x + qt.plotScaleFactor*cBlocks(i).U(1:2:end);
            yDisp = y + qt.plotScaleFactor*cBlocks(i).U(2:2:end);
            
            %get strain/stress for each node for each node in block
            id = oldInd(cBlocks(i).gID(1:end-1));
            c = save(sInd,id)';
            %'LineStype','none'
            if qt.plotDisplaced
                patch(xDisp,yDisp,c,'LineStyle','none')
            else
                patch(x,y,c,'LineStyle','none')
            end

        else
            for j = 1:1:length(cBlocks(i).polygon)
                    %get x and y components of each node in block
                    x = cBlocks(i).polygon(j).nodes(:,1);
                    y = cBlocks(i).polygon(j).nodes(:,2);

                    xDisp = x + qt.plotScaleFactor*cBlocks(i).polygon(j).U(1:2:end);
                    yDisp = y + qt.plotScaleFactor*cBlocks(i).polygon(j).U(2:2:end);

                    %get strain/stress for each node for each node in block
                    id = oldInd(cBlocks(i).polygon(j).gID);
                    c = save(sInd,id)';
                    
                if isfield(cBlocks(i).polygon(j),'cracked')
                    %add scaling center displacement
                    %find rigid body translations
                    lambda = diag(cBlocks(i).polygon(j).lambda);
                    rigidInd = find(lambda>-0.1);
                    %determine new scaling center location
                    C = cBlocks(i).polygon(j).Q \ cBlocks(i).polygon(j).U;
                    SCDisp = cBlocks(i).polygon(j).Q(1:FEM.DOFPerNode,rigidInd)*C(rigidInd,1);
                    xFill = [xDisp;cBlocks(i).polygon(j).SC(1,1)+SCDisp(1,1)*qt.plotScaleFactor];
                    yFill = [yDisp;cBlocks(i).polygon(j).SC(1,2)+SCDisp(2,1)*qt.plotScaleFactor];
                    if qt.plotDisplaced
                        patch(xFill,yFill,[c;mean(c)],'LineStyle','none')
                    else
                        patch(x,y,c,'LineStyle','none')
                    end

                else
                    %'LineStype','none'
                    if qt.plotDisplaced
                        patch(xDisp,yDisp,c,'LineStyle','none')
                    else
                        patch(x,y,c,'LineStyle','none')
                    end
                end
            end
        end
    end
    colormap(jet(24))
    %caxis([0.84 1.89])
    axis equal
    hold off
