%%
    elementFactor = 1:2:25;
    nodalOrder = 2:1:6;
    numberOfRuns = 10;
    outputSaveRawE1 = cell(numberOfRuns,length(elementFactor),length(nodalOrder));
    outputSaveRawE2 = cell(numberOfRuns,length(elementFactor),length(nodalOrder));
    outputSaveRawE3 = cell(numberOfRuns,length(elementFactor),length(nodalOrder));
%%
%Example 1: Double edge crack
    %run 10 times for timings
    for r = 1:1:length(elementFactor)
        for t = 1:1:length(nodalOrder)
            for s = 1:1:numberOfRuns
                sprintf('t = %d, r = %d, s = %d', t,r,s)
                [FEM,SD] = inputFile_4(elementFactor(r),nodalOrder(t),);
                %run analysis and save results
                SBFEM_2D_static
                outputSaveRawE1{s,r,t} = output;
            end
        end
    end
  
%%
%Example 2: embedded crack at 45 degrees
    crackAngle = pi/4;
    %run 10 times for timings
    for r = 1:1:length(elementFactor)
        for t = 1:1:length(nodalOrder)
            for s = 1:1:numberOfRuns
                sprintf('t = %d, r = %d, s = %d', t,r,s)
                [FEM,SD] = inputFile_4(elementFactor(r),nodalOrder(t),crackAngle);
                %run analysis and save results
                SBFEM_2D_static
                outputSaveRawE2{s,r,t} = output;
            end
        end
    end
    
%%
%Example 3: embedded crack at 30 degrees
    crackAngle = pi/6;
    %run 10 times for timings
    for r = 1:1:length(elementFactor)
        for t = 1:1:length(nodalOrder)
            for s = 1:1:numberOfRuns
                sprintf('t = %d, r = %d, s = %d', t,r,s)
                [FEM,SD] = inputFile_4(elementFactor(r),nodalOrder(t),crackAngle);
                %run analysis and save results
                SBFEM_2D_static
                outputSaveRawE2{s,r,t} = output;
            end
        end
    end