function [ D ] = constitutiveMatrix2D( youngsModulus , poissonRatio , constitutiveLaw )
    %parameters for abbreviation
        E = youngsModulus;
        v = poissonRatio;
    
    switch constitutiveLaw
        case(1) %Plain strain
            D =  E / ( ( 1 + v ) * ( 1 - 2 * v ) ) * ...
                [ 1 - v ,     v ,                 0 ;...
                      v , 1 - v ,                 0 ;...
                      0 ,      0, ( 1 - 2 * v ) / 2 ];
        case(2) %Plain stress
            D =  E / ( 1 - v ^ 2 ) * ...
                [ 1 , v ,             0 ;...
                  v , 1 ,             0 ;...
                  0 , 0 , ( 1 - v ) / 2 ];
        otherwise
            disp('invalid input for constitutive matrix!')
    end
