function [singularInd, singularLambda, singularC] = findSingularResponse(FEM, SD)
    %determine indices of singular contributions
    singularInd = find(SD.lambda>-0.9 & SD.lambda<-0.1);
    
    %determine singular eigenvalues
    singularLambda(1) = SD.lambda(singularInd(1),1);
    singularLambda(2) = SD.lambda(singularInd(2),1);

    %integration constants corresponding to singular eigenvalues
    singularC(1) = SD.C(singularInd(1),1);
    singularC(2) = SD.C(singularInd(2),1);
end