for i = 1:1:100000

% Element 5A
K = SD.K;

theta = 3*pi/2;
c = cos(theta);
s = sin(theta);
r =[c,-s;s,c];

R = blkdiag(r,r,r,r,r);

K = R'*K*R;

%permute
%permutation = [9,10,1,2,3,4,5,6,7,8]; %5A-->5B
%permutation = [7,8,9,10,1,2,3,4,5,6]; %5A-->5C
permutation = [5,6,7,8,9,10,1,2,3,4]; %5A-->5D
K = K(permutation,permutation);
end

%%  Polygon clipping with matlab
x2 = [0,1,1,0]
y2 = [0,0,1,1]
scale = 0.5
x1 = [0,1,1,0]*scale+scale
y1 = [0,0,1,1]*scale+scale

[x1,y1] = poly2cw(x1,y1);
[x2,y2] = poly2cw(x2,y2);

[xa, ya] = polybool('union', x1, y1, x2, y2);
[xb, yb] = polybool('intersection', x1, y1, x2, y2);
[xc, yc] = polybool('xor', x1, y1, x2, y2);
[xd, yd] = polybool('subtraction', x1, y1, x2, y2);

subplot(2, 2, 1)
patch(xa, ya, 1, 'FaceColor', 'r')
axis equal, axis off, hold on
plot(x1, y1, x2, y2, 'Color', 'k')
title('Union')

subplot(2, 2, 2)
patch(xb, yb, 1, 'FaceColor', 'r')
axis equal, axis off, hold on
plot(x1, y1, x2, y2, 'Color', 'k')
title('Intersection')

subplot(2, 2, 3)
% The output of the exclusive-or operation consists of disjoint
% regions.  It can be plotted as a single patch object using the
% face-vertex form.  Use poly2fv to convert a polygonal region
% to face-vertex form.
[f, v] = poly2fv(xc, yc);
patch('Faces', f, 'Vertices', v, 'FaceColor', 'r', ...
  'EdgeColor', 'none')
axis equal, axis off, hold on
plot(x1, y1, x2, y2, 'Color', 'k')
title('Exclusive Or')

subplot(2, 2, 4)
patch(xd, yd, 1, 'FaceColor', 'r')
axis equal, hold on
plot(x1, y1, x2, y2, 'Color', 'k')
title('Subtraction')

%%  Polygon clipping with intermediate points on horizontal and vertical line
x1 = [0,0.5,1,1.0,1,0.5,0,0.0,0];
y1 = [0,0.0,0,0.5,1,1.0,1,0.5,0];
x2 = x1+0.25;
y2 = y1+0.25;

thetad  = 45;
R       = [cosd(thetad) -sind(thetad); sind(thetad) cosd(thetad)];
C       = repmat([0.5 0.5], 9, 1)'
V = R*([x1;y1])
x1 = V(1,:)
y1 = V(2,:)
C       = repmat([0.75 0.75], 9, 1)'
V = R*([x2;y2])
x2 = V(1,:)
y2 = V(2,:)

checkConvex(x1',y1')

[x1,y1] = poly2cw(x1,y1);
[x2,y2] = poly2cw(x2,y2);
[xa, ya] = polybool('union', x1, y1, x2, y2);
[xb, yb] = polybool('intersection', x1, y1, x2, y2);
[xc, yc] = polybool('xor', x1, y1, x2, y2);
[xd, yd] = polybool('subtraction', x1, y1, x2, y2);
hold on
subplot(2, 2, 1)
patch(xa, ya, 1, 'FaceColor', 'r')
axis equal, axis off, hold on
plot(x1, y1, x2, y2, 'Color', 'k')
title('Union')

subplot(2, 2, 2)
patch(xb, yb, 1, 'FaceColor', 'r')
axis equal, axis off, hold on
plot(x1, y1, x2, y2, 'Color', 'k')
title('Intersection')

subplot(2, 2, 3)
% The output of the exclusive-or operation consists of disjoint
% regions.  It can be plotted as a single patch object using the
% face-vertex form.  Use poly2fv to convert a polygonal region
% to face-vertex form.
[f, v] = poly2fv(xc, yc);
patch('Faces', f, 'Vertices', v, 'FaceColor', 'r', ...
  'EdgeColor', 'none')
axis equal, axis off, hold on
plot(x1, y1, x2, y2, 'Color', 'k')
title('Exclusive Or')

subplot(2, 2, 4)
patch(xd, yd, 1, 'FaceColor', 'r')
axis equal, hold on
plot(x1, y1, x2, y2, 'Color', 'k')
title('Subtraction')

hold off

%%  
%%  Polygon clipping with matlab

thetad  = 45;
R       = [cosd(thetad) -sind(thetad); sind(thetad) cosd(thetad)];

P1x = [0,0,1,1,0];
P1y = [0,1,1,0,0];
P2x = P1x + 1;
P2y = P1y;
P3x = P1x;
P3y = P1y+1;
P4x = P1x + 1;
P4y = P1y + 1;

P5x = [2,2,2,3,4,4,4,3,2]-2
P5y = [2,3,4,4,4,3,2,2,2]
P6x = [2,2,2,3,4,4,4,3,2];
P6y = P5y;

V = R*([P1x;P1y])
P1x = V(1,:)
P1y = V(2,:)

V = R*([P2x;P2y])
P2x = V(1,:)
P2y = V(2,:)

V = R*([P3x;P3y])
P3x = V(1,:)
P3y = V(2,:)

V = R*([P4x;P4y])
P4x = V(1,:)
P4y = V(2,:)

V = R*([P5x;P5y])
P5x = V(1,:)
P5y = V(2,:)

V = R*([P6x;P6y])
P6x = V(1,:)
P6y = V(2,:)

P7x = [-1,-1,10,-1]
P7y = [-1, 5,-1,-1]

V = R*([P7x;P7y])
P7x = V(1,:)
P7y = V(2,:)

Ax = {P1x,P2x,P3x,P4x,P5x,P6x}
Ay = {P1y,P2y,P3y,P4y,P5y,P6y}
[Ax,Ay] = poly2cw(Ax,Ay);

Bx = {P7x}
By = {P7y}
[Bx,By] = poly2cw(Bx,By);

[xa, ya] = polybool('union', Ax, Ay, Bx, By);
[xb, yb] = polybool('intersection', Ax, Ay, Bx, By);
[xc, yc] = polybool('xor', Ax, Ay, Bx, By);
[xd, yd] = polybool('subtraction', Ax, Ay, Bx, By);

subplot(2, 2, 1)
[f, v] = poly2fv(xa, ya);
patch('Faces', f, 'Vertices', v, 'FaceColor', 'r', ...
  'EdgeColor', 'none')
axis equal, axis off, hold on
for i = 1:1:6
    plot(Ax{i},Ay{i},'k')
end
plot(Bx{1},By{1},'k')
title('Union')

subplot(2, 2, 2)
[f, v] = poly2fv(xb, yb);
patch('Faces', f, 'Vertices', v, 'FaceColor', 'r', ...
  'EdgeColor', 'none')
axis equal, axis off, hold on
for i = 1:1:6
    plot(Ax{i},Ay{i},'k')
end
plot(Bx{1},By{1},'k')
title('Intersection')

subplot(2, 2, 3)
[f, v] = poly2fv(xc, yc);
patch('Faces', f, 'Vertices', v, 'FaceColor', 'r', ...
  'EdgeColor', 'none')
axis equal, axis off, hold on
for i = 1:1:6
    plot(Ax{i},Ay{i},'k')
end
plot(Bx{1},By{1},'k')
title('Exclusive Or')

subplot(2, 2, 4)
[f, v] = poly2fv(xd, yd);
patch('Faces', f, 'Vertices', v, 'FaceColor', 'r', ...
  'EdgeColor', 'none')
axis equal, hold on
for i = 1:1:6
    plot(Ax{i},Ay{i},'k')
end
plot(Bx{1},By{1},'k')
title('Subtraction')
 
%%
%%% sample code %%%%%% 
for k=1:10 

small_box = [ 1/3 1/3; 1/3 2/3; 2/3 2/3; 2/3 1/3]; 
N = 1000000; 

A = rand(N,1); 
B = rand(N,1); 

% figure; hold on; 
% plot(A,B,'.') 
% patch([small_box(:,1); nan],[small_box(:,2); nan],ones(5,1)) 

tic; in = inpolygon(A,B,small_box(:,1),small_box(:,2)); t1=toc
tic; in2 = inpoly([A B],small_box); t2=toc

time_in_sec = struct('inpolygon',t1,'inpoly',t2); 
if t2<t1 
fprintf('inpoly is %f seconds faster\n',t1-t2) 
else 
fprintf('inpolygon is %f seconds faster\n',t2-t1) 
end 

% plot(A(in),B(in),'.r') 
% plot(A(in2),B(in2),'.g') 

end 
%%%%%%%%%

%%
%testing polyxpoly as an alternative to polygon clipping
tic
for i = 1%:1:1000
% Define and fill a rectangular area in the plane
xlimit = [3 13];
ylimit = [2  8];
%xlimit = [400 600];
%ylimit = [50  400];
xbox = [xlimit([1 1 2 2 1]),NaN,xlimit([1 1 2 2 1])+3];
ybox = [ylimit([1 2 2 1 1]),NaN,ylimit([1 2 2 1 1])+4];
mapshow(xbox,ybox,'DisplayType','polygon','LineStyle','none')
 
% Define and display a two-part polyline
x = [0 6  4  8 8 10 14 10 14 NaN 4 4 6 9 15];
y = [4 6 10 11 7  6 10 10  6 NaN 0 3 4 3  6];
%x = qt.domainExp(:,1);
%y = qt.domainExp(:,2);
mapshow(x,y,'Marker','+')

% Intersect the polyline with the rectangle
%[xi, yi,ii] = polyxpoly(x, y, xbox, ybox);
[xi, yi,ii] = polyxpoly(xbox, ybox, x, y);
mapshow(xi,yi,'DisplayType','point','Marker','o')
end    
toc

%%
x = [0 1 1 0 0];
y = [0 0 1 1 0];
ispolycw(x, y)                     % Returns 0
ispolycw(fliplr(x), fliplr(y))     % Returns 1

%%
hold on
axis equal
blockIndex = 1729
for s = 1:1:length(cBlocks(blockIndex).polygon)
    plot(cBlocks(blockIndex).polygon(s).nodes(:,1),cBlocks(blockIndex).polygon(s).nodes(:,2)  )
    pause(1)
end
hold off 

%%
fullSet = 1:1:size(globalNodes,1);
%tID

first_Set=setdiff(fullSet,tID)';
hold on
scatter(globalNodes(first_Set,1),globalNodes(first_Set,2))
%axis equal
hold off

%%
id=16;
tol = 10^-6;
K = groups.type(id).K
Q = groups.type(id).Q
temp = Q'*K*Q
temp(temp<tol)=0;

%%
vector = [1, 3; 2,1];
matrix = [2 1; 2 2;1 3; 3 4;0 0; 0 0;5 4; 3 2];  
%// example data
[dist,~] = pdist2(vector, matrix, 'euclidean','smallest',1)  %// compute distances
mindist = min(dist)                                           %// minimum distance
result = find(dist==mindist)                               %// minimizing rows





































































%% fast ismember detection
for i = 1:1:qt.nActive
A = loc
B = oldInd(cBlocks(i).gID(1:end-1));
C = fastintersect(A,B)
if ~isempty(C)
    break
end
end
function C = fastintersect(A,B)
if ~isempty(A)&&~isempty(B)
   P = zeros(1, max(max(A),max(B)) ) ;
   P(A) = 1;
   P(B)
   logical(P(B))
   C = B(logical(P(B)))
else
    C = [];
end
end










