if isfield(qt,'fixedPoints')
    disp('fixed points found!')
    %find closest nodes
    dist = pdist2(qt.fixedPoints, globalNodes, 'euclidean');
    mindist = min(dist,[],2);
    [convertNodeID,closestNodes] = find(dist==mindist);
    
    %find blocks attached to this node
    offset  = [1,1,-1,1,-1,-1,1,-1] .* qt.decompMin/2*scale;
    cPoints = repmat(globalNodes(closestNodes,:),1,4) + offset;
    cPoints = reshape(cPoints', 2, [])';
    
    %discard cPoints outside of domain limits
    indomain = (cPoints(:,1)>=0 & cPoints(:,1)<= qt.size) & ...
               (cPoints(:,2)>=0 & cPoints(:,2)<= qt.size);
    %initialize neighbour vector
    nVec = zeros(size(cPoints,1),1);
    for k = 1:1:size(cPoints,1)
        %check if current point is inside domain
        if ~indomain(k) 
            %do nothing as point is outside domain
        else %point inside domain
            nInd = 1;
            while (qtArray(nInd,active)~=1)
                %function "seedQuadrant" unrolled
                cx = (qtArray(nInd,width)-1)/2+qtArray(nInd,pos(1));
                cy = (qtArray(nInd,width)-1)/2+qtArray(nInd,pos(2));
                cx = cx*scale;cy =cy*scale;
                a = atan2(cPoints(k,2)-cy(1),cPoints(k,1)-cx(1));
                if ( a>    0 && a<=   pi/2); quadrant = 1;end; if ( a> pi/2 && a<=   pi  ); quadrant = 2;end; if ( a>-pi   && a<=  -pi/2); quadrant = 3;end; if ( a>-pi/2 && a<=      0); quadrant = 4;end
                    nInd = qtArray(nInd,kids(quadrant));
            end
            nVec(k,1) = nInd; %gain approximate neighbour by replacing with "nInd"
        end
    end
    
    for i =1:1:length(closestNodes)
        %determine slice of nVec corresponding to each node
        slot = i*4-(length(offset)/2-1):i*4;
        %determine blocks associated with each node
        blocks = nVec(slot);
        %delete blocks equal to zero corresponding to points outside of domain
        blocks(blocks==0)=[];
        %unqiue blocks
        blocks = unique(blocks);
        for j =1:1:length(blocks)
            tempInd = find(activeId==blocks(j));
            boolInd = ismembertol(cBlocks(tempInd).nodes,globalNodes(closestNodes(i),:),'ByRows',true);
            %remake as polygon
            cBlocks(tempInd).polygon.nodes = cBlocks(tempInd).nodes(1:end-1,:);
            cBlocks(tempInd).polygon.groupId = cBlocks(tempInd).groupID;
            cBlocks(tempInd).polygon.gID = cBlocks(tempInd).gID(1:end-1);
            
            %move node
            cBlocks(tempInd).polygon.nodes(boolInd(1:end-1),:) = qt.fixedPoints(convertNodeID(i),:);
            
            %adjust scaling center
            cBlocks(tempInd).polygon.SC= [mean(cBlocks(tempInd).polygon.nodes(:,1)),mean(cBlocks(tempInd).polygon.nodes(:,2))];
            
        end
    end

end













