for i = 1:1:size(qt.SIFBlocks,1)
    %retrieve block information
    b = cBlocks(qt.SIFBlocks(i,1)).polygon(qt.SIFBlocks(i,2));
    
    %locate indices of singular blocks
    sInd = find(diag(b.lambda)<0-FEM.tol & diag(b.lambda)>-1+FEM.tol);
    
    b.sQ = b.Q(:,sInd);
    b.sL = b.lambda(sInd,sInd);
    %b.sL(1,2) = 0;
    
    b.sC = b.C(sInd);
    
    %calculate the crack angle and crack length
    b.cAngle  = atan2d( b.SC(1,2)-mean([b.nodes(1,2),b.nodes(end,2)]),...
                        b.SC(1,1)-mean([b.nodes(1,1),b.nodes(end,1)]));
    b.cLength = sqrt( (b.SC(1,1)-mean([b.nodes(1,1),b.nodes(end,1)]))^2+...
                      (b.SC(1,2)-mean([b.nodes(1,2),b.nodes(end,2)]))^2);
    
    b.charL = 2*b.cLength;
    
    %calculate and interpolate the singular stress mode
    b.phi = calcSIFStressModes(b,FEM);
    
    %calculate the generalized SIDs K_I and K_II
    gSIFs = sqrt(2*pi*b.charL)*b.phi(2:3,:)*b.sC;
    
    %calculate crack propagation angle (maximum circumferential stress)
    ratio = gSIFs(2)/gSIFs(1);
    pAngle = 2*atand(-2*ratio/(1+sqrt(1+8*ratio^2)));
    
    %update crack path with new increment
    %crack.points = 0;
    
    %r = 0.5;
    %K1 = qt.loadMagnitude*sqrt(pi*0.5)*(1.122-0.231*r+10.55*r^2-21.71*r^3+30.382*r^4)
    
end