function [qt, poly, domain, feature, crack, groups, FEM, BC, grids] = Input_File_NumEx_1_ID()
%%  Quadtree related
    qt.decompMin            =   16;
    qt.decompMax            =   64;
    qt.size                 = 1024;
    qt.nKids                =    4;
    qt.maxSeeds             =    1;
    qt.decompDoubleBalanced =    0;
    
%%  Polygon clipping related
    poly.rotAngle = 45;
    
%%  Plotting
    qt.plotScaleFactor = 0;
    qt.plotUnbalanced  = 0;
    qt.plotBalanced    = 0;
    qt.plotDomain      = 0;
    qt.plotTransition  = 0;
    qt.plotFinalMesh   = 0;
    
%%  Crack id related
    qt.algorithm = 'PSO'; %'GA','GA_bitstring','PSO','PatternSearch','CMA-ES'//,'Bayesian','Adam'
    qt.fitFunction = 1;
    qt.type = 'crack';
    
%%  Global FEM parameters
    FEM.nodesPerElement   = 2;  %currently the code is locked in to 2-noded elements
    FEM.quadratureType    = 1;  %Gauss = 1, Lobatto = 2
    FEM.constitutiveLaw   = 2;

    FEM.DOFPerNode = 2;
    FEM.DOFPerElement   = FEM.DOFPerNode * FEM.nodesPerElement;
    
    FEM.tol = 10^-5;    
    
%%  Domains
    domainMultiplier  = 13;

    domain(1).type  = {'polyline','plus',1};
    domain(1).edges = [0,0;1,0;1,1;0,1];
    domain(1).seeds = domainMultiplier.*[10,10,10,10];
    
%%  Features
    feature = [];
    
%%  Cracks
    %crack(1).points = [-0.1,0.49;0.49,0.49];
    %crack(1).points = [-0.1,0.1;0.49,0.49];
    %crack(1).points = [0.49+0.27,0.27;0.49,0.49];
    %crack(1).points = [0.47,0.47;0.49,0.49];
    %crack(1).points = [0.37,0.37;0.49,0.49];
    %crack(1).points = [1-0.49,0.49;1-0.37,0.37];
    %{
    x = round(rand(1,24));
    [c] = convertCrack_2pts(x);
    crack(1).points = reshape(c,2,2);
    crack(1).points
    
    %discard when both points outside domain or both points coincide
    temp = crack(1).points(:);
    temp(temp<0) = [];
    temp(temp>1) = [];
    if length(temp)<=2
        crack(1).points = [1-0.49,0.49;1-0.37,0.37];
    end
    if crack(1).points(1,:)==crack(1).points(2,:)
        crack(1).points = [1-0.49,0.49;1-0.37,0.37];
    end
    
    %}
    %crack(1).points = [0.3828,-0.0078;0.1328,0.0859];
    %crack(1).points = [0.9453,0.1172;1.0078,0.7109];
    %crack(1).points = [0.1953,0.2578;0.1172,-0.0078];
    
    %crack(1).points = [0.1328,0.3359;0.1172,0.3516];
    
    %dummy variable for precompute
    crack(1).points = [0.1328,0.3359;0.1172,0.3516];
    
%%  Material properties of each group
    groups(1).E = 100;
    groups(1).v = 0.3;
    
%%  Sensors
    grids(1).type = 'perSide';
    grids(1).amount = 4;
    grids(1).component = 1:3;
    
%%  Loading

%%  Boundary conditions
    BC(1).set   = {'set','bottom'};    %first side of domain 1
    BC(1).coord = [1,1];                %enforce on both (x,y)-DOF
    BC(1).value = [0,0];                %restrained against displacement
    
    BC(2).set   = {'set','top'};       %third side of domain 1
    BC(2).coord = [0,1];                %enforce on y-DOF
    BC(2).value = [0,0.1];                %displacement of 1 IN UNSCALED UNITS!restrained against displacement
    

end





















