function f = SBFEM_Update(x,...
                         BC, crack, domain, feature, groups, poly, grids,...
                         qt,FEM,...
                         scale, crackLine, crackRange, gridX, gridY, points,...
                         qtArray, activeId, qtActive, qtPoints, typeArray,...
                         cBlocks,...
                         active, kids, level, nSeeds, parent, pos, root, width,...
                         f_ref)
                    
%%  Discard unfeasible condidates
    discardUnfeasibileCandidates
    
if exist('f','var');return;end

%%  update crack signed distance function
    updatePreProcessor

%%  Update quadtree
    %--> still update for inclusion
    updateQuadtree
    
    %qtPlot
    
%%  Perform update if mesh has been modified by crack introduction
if exist('sBlocks','var')
    
%%  update classifyBlocks
    updateClassifyBlocks
    
%%  update blockInfo
    updateBlockInfo
    
%%  update splitTransitionBlocks
    updateSplitTransitionBlocks
    
end
    
%%  splitCrackBlocks
    splitCrackBlocks
    
%%  scale back geometry
    scaleGeometryBack
    
%%  assign global DOF
    assignGlobalDOF
    
    %qtPlotPreProcessorMesh
    
%%  Initianlze loading vector
    FEM.F = zeros(FEM.nDOF,1);

%%  Update stiffness matrix of polygons
    updatePolygonK
    
%%  assemble stiffness matrix (unchanged)
    assembleK
    
%%  enforce boundary conditions (unchanged)
    enforceBC
    
%%  solve finite element equilibrium equation U = K\F (unchanged)
    FEM.U = FEM.K\FEM.F;
    
%%  compute displacements for each block (unchanged)
    postDisplacements
    
%%  determine integration constants for each block (unchanged)
    postIntC
    
    %qtPlotDisplacements
    
%%  compute strains at sensor locations (unchanged)
    postStrainSensor
    
%%  Compute norm
    switch qt.fitFunction
        case 1
            %disp('Objective function: absolute values');
            f = norm(f_calc(:)-f_ref(:))/norm(f_ref(:));
        case 2
            %disp('Objective function: relative values');
        case 3
            %fprintf('Objective function: relative values normalized to %d',a);
        case 4
            %disp('Objective function: relative values normlaized with exp');
        case 5
            %disp('Objective function: weighted distance to sensors');
        otherwise; disp('objective function case not implemented yet')
    end
    
%%  for plotting purposes
        %postStrain
    %plot strain and stress results
        %qt.plotField     = 'stress';
        %qt.plotFieldType = 'von Mises'; 
        %qt.plotDisplaced = 1;
        %qtPlotStrainStress
        
end
