switch qt.type
    case 'crack'
%%  Determine if crack tips are in domain
    logVec = ispolycw(qt.domainExp(:,1),qt.domainExp(:,2));
    [xPoints,yPoints] = polysplit(qt.domainExp(:,1),qt.domainExp(:,2));
    xPoints = xPoints{logVec}*scale;
    yPoints = yPoints{logVec}*scale;

%%  Obtain crack
    switch qt.algorithm
        case 'GA_bitstring'
            [c] = convertX_2CrackPoints(x);
            crack(1).points = reshape(c,2,2);
            crack(1).points;
            
            %discard when both points outside of domain
            in = inpolygon(crack(1).points(:,1)',crack(1).points(:,2)',xPoints,yPoints);
            if ~any(in)
                f = NaN; return
            end

            %discard when both points coincide
            if crack(1).points(1,:)==crack(1).points(2,:)
                f = NaN; return
            end
            
        case {'GA','PSO','PatternSearch','CMA-ES','Adam'}
            crack(1).points = real([x(1),x(2);x(3),x(4)]);
            crack(1).points;
            
            %discard when both points outside of domain
            in = inpolygon(crack(1).points(:,1)',crack(1).points(:,2)',xPoints,yPoints);
            if ~any(in)
                f = NaN; return
            end
            
            %discard when distance between points smaller than qt.decompMin
            distance = sqrt((x(1)-x(3))^2+(x(2)-x(4))^2)/scale;
            if distance < qt.decompMin * sqrt(2)
                f = NaN; return
            end
            
        case 'Bayesian'
            x = table2array(x);
            
            crack(1).points = [x(1),x(2);x(3),x(4)];
            crack(1).points;
            
            %discard when both points outside of domain
            in = inpolygon(crack(1).points(:,1)',crack(1).points(:,2)',xPoints,yPoints);
            if ~any(in)
                f = NaN; return
            end
            
            %discard when distance between points smaller than qt.decompMin
            distance = sqrt((x(1)-x(3))^2+(x(2)-x(4))^2)/scale;
            if distance < qt.decompMin * sqrt(2)
                f = NaN; return
            end
    end
    
    case 'inclusion'
        %Determine if inclusion is inside domain
            %--> not necessary since no domain segmentation possible
        %Limit minimum size of inclusion
            %--> should not be smaller than qt.DecompMin
            
        switch qt.algorithm
            case 'GA_bitstring'
                [f] = convertX_2Features(x);
                crack(1).points = reshape(c,2,2);
                crack(1).points;
                
            case {'GA','PSO','PatternSearch','CMA-ES'}
                
        end
        
        
end