function f_ref = qtSBFEM_ref(numericalExample)
%%  Reset
    clear cBlocks
    
%%  Input file
    switch numericalExample
        case 1
            [qt, poly, domain, feature, crack, groups, FEM, BC, grids] = Input_File_NumEx_1_ref();
        otherwise; disp('not implemented yet')
    end
    
%%  Prepocessor (hope this can be done in just around 1 sec)
    %parse input file by constructing explicit and implicit geometry representations
    preProcessor
    
    %unbalanced quadtree decomposition
    qtDecompUnbalanced
    
    %balance quadtree decomposition
    qtDecompBalance

    %classify blocks
    classifyBocks
    
    %determine general block information
    blockInfo

    %split transition blocks based on their signed distance function
    splitTransitionBlocks

    %add crack
    splitCrackBlocks

    %scale all dimensions back to original size
    scaleGeometryBack

    %find global identifiers for all nodes
    assignGlobalDOF
    
    %qtPlotPreProcessorMesh

%%  Processor    
    %determine loading
    FEM.F = zeros(FEM.nDOF,1);
        
    %precalc stiffness matrices
    precomputeK


    %determine stiffness matrix for all polygons
    polygonK

    %assemble K
    assembleK

    %determine boundary conditions
    enforceBC

    %solve finite element equilibrium equation U = K\F
    FEM.U = FEM.K\FEM.F;
        
%%  Postprocessor
    %determine displacements for each polygon
    postDisplacements
    
    %determine coefficient vector
    postIntC
    
    %determine strains and stress at nodes
    postStrain
    
    qt.plotField     = 'stress';
    qt.plotFieldType = 'von Mises'; 
    qt.plotDisplaced = 1;
    %qtPlotStrainStress
    
    %output strain at predefined sensor locations
    postStrainSensor
    
    f_ref = strainAtNodes(1:3,:);
return






