%delete inactivated cBlocks
    cBlocks(indA) = [];

%initialiaze new cBlocks
    cBlocks(qt.nActive).groupID   = -1;
    cBlocks(qt.nActive).crack     = -1;
    cBlocks(qt.nActive).levelDiff = -1;
    cBlocks(qt.nActive).blockType = -1;

%%  Determine approxmative neighbours for each refined block
    nId = zeros(qt.nUpdate,4);
    counter = 1;
    for i = indU(1):1:indU(end)
        %retrieve all position points and offset to obtain center points
        cPoints = qtActive(i,pos)+(qtActive(i,width)-1)/2;
        %ofset in four neighbour drections
        offset  = [0,1,-1,0,0,-1,1,0] .* qtActive(i,width);
        cPoints = repmat(cPoints,1,4) + offset;
        cPoints = reshape(cPoints', 2, [])';
        %discard cPoints outside of domain limits
        cPoints = cPoints((cPoints(:,1)>=0 & cPoints(:,1)<= qt.size),:);
        cPoints = cPoints((cPoints(:,2)>=0 & cPoints(:,2)<= qt.size),:);
        %initialize neighbour vector
        nVec = zeros(1,4);
        for k = 1:1:size(cPoints,1)
            nInd = 1;
            while (qtArray(nInd,active)~=1)
                %function "seedQuadrant" unrolled
                cx = (qtArray(nInd,width)-1)/2+qtArray(nInd,pos(1));
                cy = (qtArray(nInd,width)-1)/2+qtArray(nInd,pos(2));
                a = atan2(cPoints(k,2)-cy(1),cPoints(k,1)-cx(1));
                if ( a>    0 && a<=   pi/2); quadrant = 1;end; if ( a> pi/2 && a<=   pi  ); quadrant = 2;end; if ( a>-pi   && a<=  -pi/2); quadrant = 3;end; if ( a>-pi/2 && a<=      0); quadrant = 4;end
                    nInd = qtArray(nInd,kids(quadrant));
            end
            nVec(1,k) = qtArray(nInd,level); %gain approximate neighbour by replacing with "nInd"
            nId(counter,k) = nInd;
        end
        counter = counter + 1;
        
        blockLevel = qtActive(i,level);
        cBlocks(i).levelDiff = nVec - blockLevel;
        cBlocks(i).levelDiff(cBlocks(i).levelDiff>0) = 1;
        cBlocks(i).levelDiff(cBlocks(i).levelDiff<1) = 0;
    end
    
%%  Determine blockType and assign nodes to each block
    for  i = indU(1):1:indU(end)
        nIntNodes = sum(cBlocks(i).levelDiff);
        switch nIntNodes
            case 0; blockType =  1; cBlocks(i).nodes = [1,1;0,1;0,0;1,0];
            case 4; blockType = 16; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0.5;0,0;0.5,0;1,0;1,0.5];
            case 1 %one side node
                tempInd = find(cBlocks(i).levelDiff);
                switch tempInd
                    case 1; blockType =  4; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0;1,0];
                    case 2; blockType =  5; cBlocks(i).nodes = [1,1;0,1;0,0.5;0,0;1,0];
                    case 3; blockType =  2; cBlocks(i).nodes = [1,1;0,1;0,0;0.5,0;1,0];
                    case 4; blockType =  3; cBlocks(i).nodes = [1,1;0,1;0,0;1,0;1,0.5];
                end

            case 2 %two side nodes
                tempInd = find(cBlocks(i).levelDiff);
                if tempInd == [1,2]; blockType =  8; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0.5;0,0;1,0];end
                if tempInd == [2,3]; blockType =  9; cBlocks(i).nodes = [1,1;0,1;0,0.5;0,0;0.5,0;1,0];end
                if tempInd == [3,4]; blockType =  6; cBlocks(i).nodes = [1,1;0,1;0,0;0.5,0;1,0;1,0.5];end
                if tempInd == [1,4]; blockType =  7; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0;1,0;1,0.5];end
                if tempInd == [1,3]; blockType = 10; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0;0.5,0;1,0];end
                if tempInd == [2,4]; blockType = 11; cBlocks(i).nodes = [1,1;0,1;0,0.5;0,0;1,0;1,0.5];end

            case 3 %three side nodes
                tempInd = find(cBlocks(i).levelDiff==0);
                switch tempInd
                    case 1; blockType =  15; cBlocks(i).nodes = [1,1;0,1;0,0.5;0,0;0.5,0;1,0;1,0.5];
                    case 2; blockType =  12; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0;0.5,0;1,0;1,0.5];
                    case 3; blockType =  13; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0.5;0,0;1,0;1,0.5];
                    case 4; blockType =  14; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0.5;0,0;0.5,0;1,0];
                end
        end
        cBlocks(i).blockType = blockType;
        %scale nodes
        cBlocks(i).nodes = cBlocks(i).nodes*qtActive(i,width);
        %shift nodes
        cBlocks(i).nodes(:,1) = cBlocks(i).nodes(:,1) + qtActive(i,pos(1)) - 1;
        cBlocks(i).nodes(:,2) = cBlocks(i).nodes(:,2) + qtActive(i,pos(2)) - 1;
        %close polygon
        cBlocks(i).nodes = [cBlocks(i).nodes;cBlocks(i).nodes(1,:)];
    end

%%  Neigbours of refined mesh that now have to be assigned the newly generated hanging nodes
    updateBlocks = unique(nId(:));
    [~,idx]=ismember(updateBlocks,uActiveId);
    
%%  Determine approxmative neighbours for each block with modified neighbours
    counter = 1;
    for i = idx(1):1:idx(end)
        %retrieve all position points and offset to obtain center points
        cPoints = qtActive(i,pos)+(qtActive(i,width)-1)/2;
        %ofset in four neighbour drections
        offset  = [0,1,-1,0,0,-1,1,0] .* qtActive(i,width);
        cPoints = repmat(cPoints,1,4) + offset;
        cPoints = reshape(cPoints', 2, [])';
        %discard cPoints outside of domain limits
        cPoints = cPoints((cPoints(:,1)>=0 & cPoints(:,1)<= qt.size),:);
        cPoints = cPoints((cPoints(:,2)>=0 & cPoints(:,2)<= qt.size),:);
        %initialize neighbour vector
        nVec = zeros(1,4);
        for k = 1:1:size(cPoints,1)
            nInd = 1;
            while (qtArray(nInd,active)~=1)
                %function "seedQuadrant" unrolled
                cx = (qtArray(nInd,width)-1)/2+qtArray(nInd,pos(1));
                cy = (qtArray(nInd,width)-1)/2+qtArray(nInd,pos(2));
                a = atan2(cPoints(k,2)-cy(1),cPoints(k,1)-cx(1));
                if ( a>    0 && a<=   pi/2); quadrant = 1;end; if ( a> pi/2 && a<=   pi  ); quadrant = 2;end; if ( a>-pi   && a<=  -pi/2); quadrant = 3;end; if ( a>-pi/2 && a<=      0); quadrant = 4;end
                    nInd = qtArray(nInd,kids(quadrant));
            end
            nVec(1,k) = qtArray(nInd,level); %gain approximate neighbour by replacing with "nInd"
        end
        counter = counter + 1;
        
        blockLevel = qtActive(i,level);
        cBlocks(i).levelDiff = nVec - blockLevel;
        cBlocks(i).levelDiff(cBlocks(i).levelDiff>0) = 1;
        cBlocks(i).levelDiff(cBlocks(i).levelDiff<1) = 0;
    end

%%  Determine blockType and assign nodes to each block with updated neighbours
    for  i = idx(1):1:idx(end)
        nIntNodes = sum(cBlocks(i).levelDiff);
        switch nIntNodes
            case 0; blockType =  1; cBlocks(i).nodes = [1,1;0,1;0,0;1,0];
            case 4; blockType = 16; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0.5;0,0;0.5,0;1,0;1,0.5];
            case 1 %one side node
                tempInd = find(cBlocks(i).levelDiff);
                switch tempInd
                    case 1; blockType =  4; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0;1,0];
                    case 2; blockType =  5; cBlocks(i).nodes = [1,1;0,1;0,0.5;0,0;1,0];
                    case 3; blockType =  2; cBlocks(i).nodes = [1,1;0,1;0,0;0.5,0;1,0];
                    case 4; blockType =  3; cBlocks(i).nodes = [1,1;0,1;0,0;1,0;1,0.5];
                end

            case 2 %two side nodes
                tempInd = find(cBlocks(i).levelDiff);
                if tempInd == [1,2]; blockType =  8; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0.5;0,0;1,0];end
                if tempInd == [2,3]; blockType =  9; cBlocks(i).nodes = [1,1;0,1;0,0.5;0,0;0.5,0;1,0];end
                if tempInd == [3,4]; blockType =  6; cBlocks(i).nodes = [1,1;0,1;0,0;0.5,0;1,0;1,0.5];end
                if tempInd == [1,4]; blockType =  7; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0;1,0;1,0.5];end
                if tempInd == [1,3]; blockType = 10; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0;0.5,0;1,0];end
                if tempInd == [2,4]; blockType = 11; cBlocks(i).nodes = [1,1;0,1;0,0.5;0,0;1,0;1,0.5];end

            case 3 %three side nodes
                tempInd = find(cBlocks(i).levelDiff==0);
                switch tempInd
                    case 1; blockType =  15; cBlocks(i).nodes = [1,1;0,1;0,0.5;0,0;0.5,0;1,0;1,0.5];
                    case 2; blockType =  12; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0;0.5,0;1,0;1,0.5];
                    case 3; blockType =  13; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0.5;0,0;1,0;1,0.5];
                    case 4; blockType =  14; cBlocks(i).nodes = [1,1;0.5,1;0,1;0,0.5;0,0;0.5,0;1,0];
                end
        end
        cBlocks(i).blockType = blockType;
        %scale nodes
        cBlocks(i).nodes = cBlocks(i).nodes*qtActive(i,width);
        %shift nodes
        cBlocks(i).nodes(:,1) = cBlocks(i).nodes(:,1) + qtActive(i,pos(1)) - 1;
        cBlocks(i).nodes(:,2) = cBlocks(i).nodes(:,2) + qtActive(i,pos(2)) - 1;
        %close polygon
        cBlocks(i).nodes = [cBlocks(i).nodes;cBlocks(i).nodes(1,:)];
    end

    
%% initialize
cBlocks(end).polygon = [];
