%determine updated active blocks
    uActiveId = find(qtArray(1:qt.nDecomp,active)>0);
    qtActive = qtArray(uActiveId,:);
%determine the incremental new blocks to be added and the old inactive blocks to be deleted
    [specU,indU]=setdiff(uActiveId,activeId); %blocks that have to be newly treated
    [specA,indA]=setdiff(activeId,uActiveId); %blocks that have to be deleted because not active anymore
    qt.nUpdate = length(specU);


%check incremental block update
    %initialize vector to hold updates
    uTypeArray = zeros(qt.nUpdate,qt.nChecks);
    
    %check by iterating over each updated block
    counter = 1;
    for i = indU(1):1:indU(end)
        %find the corner nodes of each block
        upperEdge = qtActive(i,pos);%do not have to adjust position by -1 since sd array starts from 1 in indexing
        cNodes = [upperEdge;...
                  upperEdge + [                0,qtActive(i,width)];...
                  upperEdge + [qtActive(i,width),qtActive(i,width)];...
                  upperEdge + [qtActive(i,width),                0]];
        %check domain
        uTypeArray(counter,1) = checkDomain(cNodes,qt);
        counter = counter + 1;
    end

%delete old inactived blocks
typeArray(indA,:)=[];
%append newly updated blocks
typeArray = [typeArray;uTypeArray];
    
%adjust indexing to reflect deleted blocks
    qtActive(typeArray(:,1)==0,:) = [];
    qt.nActive = size(qtActive,1);
%Discard all blocks which are outside of area of interest (i.e. not domain or transition)
    typeArray(typeArray(:,1)==0,:) = [];