for i = indU(1):1:indU(end)
    % 1. Determine if hanging nodes present on which side

    % 2. Evaluate signed distance functions
        %determine edge points
        cPoints = cBlocks(i).nodes;
        sdVec = zeros(qt.nGroups,size(cPoints,1));
        %evaluate the signed distance functions of each group
        for j = 1:1:qt.nGroups
            for k = 1:1:size(cPoints,1)
                sdVec(j,k) = qt.featureImp{j}(cPoints(k,2)+1,cPoints(k,1)+1); %adjust as indexing starts at 1 and not 0
            end
        end
        
    % 3. Calculate intersection points
        intPoints = []; iPoint = 0;
        [row,~,~] = find(sdVec<0);
        row  = uniquetol(row);
        if row
            sdTemp = [sdVec(row(1),:),sdVec(row(1),1)];  %wrap around
            cPoints = [cPoints;cPoints(1,:)];           %wrap around
            for j = 1:1:size(sdTemp,2)-1
                temp = sign(sdTemp(1,j))*sign(sdTemp(1,j+1));
                if temp>=0   %no sign change so no intersection point
                else        %sign change and thus intersection point present
                    iPoint = iPoint + 1;
                    xS = cPoints(j  ,1);
                    xE = cPoints(j+1,1);
                    dX = xE-xS;
                    yS = cPoints(j  ,2);
                    yE = cPoints(j+1,2);
                    dY = yE-yS;
                    ratio = abs(sdTemp(j))/(abs(sdTemp(j))+abs(sdTemp(j+1)));
                    pointX = xS+dX*ratio;
                    pointY = yS+dY*ratio;
                    intPoints(iPoint,:) = [pointX,pointY];
                    %delete NaNs
                    intPoints(any(isnan(intPoints), 2), :) = [];
                end
            end
        end

    % 4. Create polygon for each split domain
        if ~isempty(intPoints)
            polyPoints = [];
            for j = 1:1:size(row,1)
                if j == 1
                   %negative values (first polygon)
                    [~,col,~] = find(sdVec(row(1),1:end-1)<=0);
                    polyPoints = [cPoints(col,:);intPoints];
                else
                    %positive values (second polygon if present)
                    [~,col,~] = find(sdVec(row(1),1:end-1)>0);
                    polyPoints = [cPoints(col,:);intPoints];
                end 
                polyPoints = uniquetol(polyPoints,'ByRows',true);


            % 5. Order polygon CCW 
                %find middle point of polygon
                nPolyPoints = size(polyPoints,1);
                cX = 0; cY = 0;
                for k = 1:1:nPolyPoints
                    cX = cX + polyPoints(k,1);
                    cY = cY + polyPoints(k,2);
                end
                cX = cX/nPolyPoints;
                cY = cY/nPolyPoints;
                a = atan2(polyPoints(:,2) - cY, polyPoints(:,1) - cX);
                [~, order] = sort(a,'ascend'); %counterclockwise
                polyPoints(:,1) = polyPoints(order,1);
                polyPoints(:,2) = polyPoints(order,2);

            % 6. Save polygons and group identifier
                cBlocks(i).polygon(j).nodes     = polyPoints;
                cBlocks(i).polygon(j).SC        = [cX,cY];
                cBlocks(i).polygon(j).groupId   = row(j);
                cBlocks(i).polygon(j).intPoints = intPoints;
            end
        else %group id for not split elements inside domain
            if row; cBlocks(i).groupID = row; end
        end
end