%initialize a save matrix for the strains and stresses
strainSave = zeros(7,size(globalNodes,1));
stressSave = zeros(7,size(globalNodes,1));
strainSave(4,:) = zeros;
stressSave(4,:) = zeros;

%querry stress and strain
for i = 1:1:qt.nActive
    if isempty(cBlocks(i).polygon)
        %for each node of the block, compute the strains
        for j = 1:1:size(cBlocks(i).nodes,1)-1
            [strain, stress] = calcStrainBlocks(cBlocks(i), groups, FEM, j);
            %recall node id
            id = oldInd(cBlocks(i).gID(j));
            %save in corresponding node position
                strainSave(1:3,id) = strainSave(1:3,id)+strain;
                stressSave(1:3,id) = stressSave(1:3,id)+stress;
            %update counter
            strainSave(4,id) = strainSave(4,id) + 1; 
            stressSave(4,id) = stressSave(4,id) + 1; 
        end
    else
        for j = 1:1:length(cBlocks(i).polygon)
            %for each node of the polygon, compute the strains
            for k = 1:1:size(cBlocks(i).polygon(j).nodes,1)
                if ~isfield(cBlocks(i).polygon(j),'cracked')
                    [strain, stress] = calcStrainPolygons(cBlocks(i).polygon(j), FEM, k);
                    %recall node id
                    id = oldInd(cBlocks(i).polygon(j).gID(k));
                    %save in corresponding node position
                    strainSave(1:3,id) = strainSave(1:3,id)+strain;
                    stressSave(1:3,id) = stressSave(1:3,id)+stress;
                    %update counter
                    strainSave(4,id) = strainSave(4,id) + 1; 
                    stressSave(4,id) = stressSave(4,id) + 1; 
                else
                    [strain, stress] = calcStrainPolygonsCracked(cBlocks(i).polygon(j), FEM, k);
                end
            end
        end
    end
end

%average stress and strain, minor principal, max principal and von mises
for  i = 1:1:size(globalNodes,1)
    %average
    strainSave(1:3,i) = strainSave(1:3,i)./strainSave(4,i);
    stressSave(1:3,i) = stressSave(1:3,i)./stressSave(4,i);
    %min principal
    exx = strainSave(1,i);
    eyy = strainSave(2,i);
    exy = strainSave(3,i);
    strainSave(5,i) = (exx+eyy)/2-sqrt(((exx-eyy)/2)^2+(exy/2)^2);
    strainSave(6,i) = (exx+eyy)/2+sqrt(((exx-eyy)/2)^2+(exy/2)^2);
    strainSave(7,i) = sqrt( exx^2 - exx*eyy + eyy^2 + 3*exy^2 );
    
    sxx = stressSave(1,i);
    syy = stressSave(2,i);
    sxy = stressSave(3,i);
    stressSave(5,i) = (sxx+syy)/2-sqrt(((sxx-syy)/2)^2+(sxy/2)^2);
    stressSave(6,i) = (sxx+syy)/2+sqrt(((sxx-syy)/2)^2+(sxy/2)^2);
    stressSave(7,i) = sqrt( sxx^2 - sxx*syy + syy^2 + 3*sxy^2 );
end


