%tic;
h = max(qtArray(1:qt.nDecomp,level));
qt.balanceInd = qt.nDecomp+1;
while h > 0
    %find all active blocks of level (starting condition)
    hInd = find( (qtArray(1:qt.nDecomp,level) == h) &  (qtArray(1:qt.nDecomp,active) == 1) );
    %skipping and breaking conditions if empty generations are present
    while ( isempty(hInd) && h>0);h = h-1; hInd = find( (qtArray(1:qt.nDecomp,level) == h) &  (qtArray(1:qt.nDecomp,active) == 1) );end; if h == 0;break;end
    %offset and unqiuetol all center points in four neighbour directions
        %retrieve all position points and offset to obtain center points
        cPoints = qtArray(hInd,pos)+(qtArray(hInd(1),width)-1)./2;
        %ofset in four neighbour drections
        if ~qt.decompDoubleBalanced
            offset  = [0,1,-1,0,0,-1,1,0] .* qtArray(hInd(1),width);
            cPoints = repmat(cPoints,1,4) + offset;
        else
            offset  = [1,1,0,1,-1,1,-1,0,-1,-1,0,-1,1,-1,1,0] .* qtArray(hInd(1),width);
            cPoints = repmat(cPoints,1,8) + offset;
        end
        cPoints = reshape(cPoints', 2, [])';
        cPoints = uniquetol(cPoints,'ByRows',true);
        %discard points outside bounding box
        inDomain = (cPoints(:,1)>0) & (cPoints(:,1)<qt.size+1) &...
                   (cPoints(:,2)>0) & (cPoints(:,2)<qt.size+1);
        cPoints  = cPoints(inDomain,:);
        

    while ~isempty(cPoints)
        %initialize splitting index vector
        sInd = ones(1,size(cPoints,1));
        
        %determine into which blocks the points fall by returning their block index
        for i = 1:1:size(cPoints,1)
            while (qtArray(sInd(i),active)~=1)
                quadrant = seedQuadrant(qtArray,cPoints(i,:),sInd(i),width,pos);
                sInd(i) = qtArray(sInd(i),kids(quadrant));
            end
        end
        
        %retain points and block indices within domain (i.e. non-zero index)
        cPoints = cPoints(sInd>0,:);
        sInd    = sInd(sInd>0);
        
        %blocks on index list with (h_block-2)>h_current must be retained for subsequent splitting check
        cPoints  = cPoints(qtArray(sInd,level)<(h-2),:);
        
        %split those blocks on index list if (h_block-1)>h_current
        sInd = sInd(qtArray(sInd,level)<(h-1));
        sInd = uniquetol(sInd);
        %split all blocks with identifiers contained in sInd vector
        for j = 1:1:length(sInd)
            id = sInd(j);
            %update parent's information
                qtArray(id,kids)   = qt.nDecomp+1 : qt.nDecomp+qt.nKids;
                qtArray(id,active) = 0;
                %update kid's information
                for i = 1:1:qt.nKids
                    kidId = qtArray(id,kids(i));
                    qtArray(kidId,parent) = id;
                    qtArray(kidId,width ) = qtArray(id,width)/ 2;
                    qtArray(kidId,active) = 1;
                    qtArray(kidId,level ) = qtArray(id,level) + 1;
                    %distribute seeds as they are positioned via function call
                    switch i
                        case 1; qtArray(kidId,pos) = qtArray(id,pos) + [qtArray(kidId,width),qtArray(kidId,width)];
                        case 4; qtArray(kidId,pos) = qtArray(id,pos) + [qtArray(kidId,width),                  0];
                        case 3; qtArray(kidId,pos) = qtArray(id,pos) + [                   0,                  0];
                        case 2; qtArray(kidId,pos) = qtArray(id,pos) + [                   0,qtArray(kidId,width)];
                    end
                end
                qt.nDecomp = qt.nDecomp + qt.nKids;
        end 
    end
    h = h - 1;
end

%%  update balanced blocks with points
    %determine parents of updated blocks
    parents = uniquetol(qtArray(qt.balanceInd:qt.nDecomp,parent))';
    %assign points from parent to children
    for id = parents
        qtArray(id,nSeeds) = 0;
        [sQ1,sQ2,sQ3,sQ4] = seedsQuadrant(qtArray,qtPoints,id,width,pos);
        %update kid's information
        for i = 1:1:qt.nKids
            kidId = qtArray(id,kids(i));
            %distribute seeds as they are positioned via function call
            switch i
                case 1; qtPoints(kidId).points = sQ1; qtArray(kidId,nSeeds) = size(qtPoints(kidId).points,1);
                case 4; qtPoints(kidId).points = sQ2; qtArray(kidId,nSeeds) = size(qtPoints(kidId).points,1);
                case 3; qtPoints(kidId).points = sQ3; qtArray(kidId,nSeeds) = size(qtPoints(kidId).points,1);
                case 2; qtPoints(kidId).points = sQ4; qtArray(kidId,nSeeds) = size(qtPoints(kidId).points,1);
            end
        end
    end

%%  Clean up
    clear cPoints inDomain h hInd i id j kidId offset quadrant sInd parents
    clear -regexp sQ
%toc