%%  Assign root level starting conditions
    %{
        1   = parent
        2:5 = kids
        6:7 = pos upper left hand corner
        8   = size
        9   = active
       10   = level
       11   = number of Seeds in block
    %}
    root   =  1;
    parent =  1;
    kids   =  2:5;
    pos    =  6:7;
    width  =  8;
    active =  9;
    level  = 10;
    nSeeds = 11;
    
    qtArray(root,parent  )  = 0;
    qtArray(root,pos     )  = [1,1];
    qtArray(root,width   )  = qt.size;
    qtArray(root,active  )  = 1;
    qtArray(root,level   )  = 0;
    qtArray(root,nSeeds  )  = qt.nPoints;
    
    %initialize struct array to hold points of each block
    qtPoints(qt.maxLeaf).points = [-1,-1];
    qtPoints(root).points = qt.pointsExp;
    
%%  Perform decomposition
    id = 1;
    qt.nDecomp = 1;
    
    doSplit = 1;
    if qt.decompMax == qt.size; doSplit = 0;end
    
    %continue while there are still valid blocks in qtArray
    while ((qtArray(id,width) ~= 0)  && doSplit && id < qt.maxLeaf)
        %criteria to split parent block and append children
        if (    (qtArray(id,width)  >    qt.decompMax)...        %direct check
             || (qtArray(id,nSeeds) >    qt.maxSeeds)...         %direct check
             && (qtArray(id,width)  >= 2*qt.decompMin)...        %direct check
           )
            %split block and append four children to qtArray, then increment "id"
                %update parent's information
                qtArray(id,kids)   = qt.nDecomp+1 : qt.nDecomp+qt.nKids;
                qtArray(id,active) = 0;
                qtArray(id,nSeeds) = 0;
                %determine which seeds belong to which quadrant
                [sQ1,sQ2,sQ3,sQ4] = seedsQuadrant(qtArray,qtPoints,id,width,pos);
                %update kid's information
                for i = 1:1:qt.nKids
                    kidId = qtArray(id,kids(i));
                    qtArray(kidId,parent) = id;
                    qtArray(kidId,width ) = qtArray(id,width)/ 2;
                    qtArray(kidId,active) = 1;
                    qtArray(kidId,level ) = qtArray(id,level) + 1;
                    %distribute seeds as they are positioned via function call
                    switch i
                        case 1; qtArray(kidId,pos) = qtArray(id,pos) + [qtArray(kidId,width),qtArray(kidId,width)];
                                qtPoints(kidId).points = sQ1; qtArray(kidId,nSeeds) = size(qtPoints(kidId).points,1);
                        case 4; qtArray(kidId,pos) = qtArray(id,pos) + [qtArray(kidId,width),                  0];
                                qtPoints(kidId).points = sQ2; qtArray(kidId,nSeeds) = size(qtPoints(kidId).points,1);
                        case 3; qtArray(kidId,pos) = qtArray(id,pos) + [                  0,                  0];
                                qtPoints(kidId).points = sQ3; qtArray(kidId,nSeeds) = size(qtPoints(kidId).points,1);
                        case 2; qtArray(kidId,pos) = qtArray(id,pos) + [                  0,qtArray(kidId,width)];
                                qtPoints(kidId).points = sQ4; qtArray(kidId,nSeeds) = size(qtPoints(kidId).points,1);
                    end
                end
                qt.nDecomp = qt.nDecomp + qt.nKids;
        end
        id = id + 1;
    end
    
%%  clean up
    clear -regexp ^sQ
    clear doSplit i id kidId