function [sQ1,sQ2,sQ3,sQ4] = seedsQuadrant(qtArray,qtPoints,id,size,pos)
    if ~isempty(qtPoints(id).points)
        %determine center of block
        cx = qtArray(id,size)/2+(qtArray(id,pos(2))-1);
        cy = qtArray(id,size)/2+(qtArray(id,pos(1))-1);

        a = atan2(qtPoints(id).points(:,1)-cy(1),qtPoints(id).points(:,2)-cx(1));

        sQ1Ind = a>=    0 & a<   pi/2;
        sQ2Ind = a>= pi/2 & a<=  pi  ;
        sQ3Ind = a>=-pi   & a<  -pi/2;
        sQ4Ind = a>=-pi/2 & a<      0;

        sQ1 = qtPoints(id).points(sQ1Ind,:);
        sQ2 = qtPoints(id).points(sQ2Ind,:);
        sQ3 = qtPoints(id).points(sQ3Ind,:);
        sQ4 = qtPoints(id).points(sQ4Ind,:);
    else
        sQ1 = []; sQ2 = []; sQ3 = []; sQ4 = [];
    end
    
end