%%  Initialize sparse storage vectors
    counter = 0;
    for i = 1:1:qt.nActive
        if  isempty(cBlocks(i).polygon)
            kind = cBlocks(i).blockType;
            stencil = groups(cBlocks(i).groupID).type(kind).K;
            counter = counter + size(stencil,1)*size(stencil,1);
        else
            for j = 1:1:length(cBlocks(i).polygon)
                stencil = cBlocks(i).polygon(j).K;
                counter = counter + size(stencil,1)*size(stencil,1); 
            end
        end
    end 

    iInd = zeros(counter,1);
    jInd = zeros(counter,1);
    val  = zeros(counter,1);
  
%%  Fill sparse storage vectors
    counter = 1;
    for i = 1:1:qt.nActive
        if isempty(cBlocks(i).polygon)
            id = cBlocks(i).gID(1:end-1);
            id = oldInd(id);
            %correct from node to DOF
            id = nodesToDOF(id,FEM.nodesPerElement);
            
            %Fetch stiffnes matrix
            kind = cBlocks(i).blockType;
            stencil = groups(cBlocks(i).groupID).type(kind).K;
            step = size(stencil,1)*size(stencil,1)-1;
            
            [idI,idJ] = meshgrid(id);
            indices = [idI(:),idJ(:)];
            values = reshape(stencil,[],1);
            iInd(counter:counter+step,1)   = indices(:,1);
            jInd(counter:counter+step,1)   = indices(:,2);
            val (counter:counter+step,1) = values;
            
            counter = counter + step+1;
            
        else
            for j = 1:1:length(cBlocks(i).polygon)
                id = cBlocks(i).polygon(j).gID;
                id = oldInd(id);
                %correct from node to DOF
                id = nodesToDOF(id,FEM.nodesPerElement);
                stencil = cBlocks(i).polygon(j).K;
                step = size(stencil,1)*size(stencil,1)-1;
                
                [idI,idJ] = meshgrid(id);
                indices = [idI(:),idJ(:)];
                values = reshape(stencil,[],1);
                iInd(counter:counter+step,1)   = indices(:,1);
                jInd(counter:counter+step,1)   = indices(:,2);
                val (counter:counter+step,1) = values;

                counter = counter + step+1;
            end
        end
    end 

%%  Reduce to sparse matrix
    spparms('spumoni',0);
    FEM.K = sparse(iInd,jInd,val);
    