%Initialize storage array for stiffness matrix, subspace vector and eigenvalues


%%  Precompute quantities for each stencil type
for i = 1:1:16
    SC = [0.5,0.5];
    switch i
        case  1;    nodes = [1,1;0,1;0,0;1,0];
        case  2;    nodes = [1,1;0,1;0,0;0.5,0;1,0];
        case  3;    nodes = [1,1;0,1;0,0;1,0;1,0.5];
        case  4;    nodes = [1,1;0.5,1;0,1;0,0;1,0];
        case  5;    nodes = [1,1;0,1;0,0.5;0,0;1,0];
        case  6;    nodes = [1,1;0,1;0,0;0.5,0;1,0;1,0.5];
        case  7;    nodes = [1,1;0.5,1;0,1;0,0;1,0;1,0.5];
        case  8;    nodes = [1,1;0.5,1;0,1;0,0.5;0,0;1,0];
        case  9;    nodes = [1,1;0,1;0,0.5;0,0;0.5,0;1,0];
        case 10;    nodes = [1,1;0.5,1;0,1;0,0;0.5,0;1,0];
        case 11;    nodes = [1,1;0,1;0,0.5;0,0;1,0;1,0.5];
        case 12;    nodes = [1,1;0.5,1;0,1;0,0;0.5,0;1,0;1,0.5];
        case 13;    nodes = [1,1;0.5,1;0,1;0,0.5;0,0;1,0;1,0.5];
        case 14;    nodes = [1,1;0.5,1;0,1;0,0.5;0,0;0.5,0;1,0];
        case 15;    nodes = [1,1;0,1;0,0.5;0,0;0.5,0;1,0;1,0.5];
        case 16;    nodes = [1,1;0.5,1;0,1;0,0.5;0,0;0.5,0;1,0;1,0.5];
    end

    numberOfElements = size(nodes,1);
    elements = zeros(numberOfElements, FEM.nodesPerElement);
    for j = 1:1:numberOfElements
        start = (j-1)*(FEM.nodesPerElement - 1) + 1;
        elements(j,:) = start: start + FEM.nodesPerElement - 1;
    end
    elements(end,end) = 1;

    for j = 1:1:qt.nGroups
        groups(j).nDOF = size(nodes,1)*FEM.DOFPerNode;
        groups(j).numberOfElements = numberOfElements;
        groups(j).nodes = nodes;
        groups(j).localElements = elements;
        groups(j).SC = SC;
        %working addressor, just need to complete FEM and SD to pass
        [groups(j).type(i).K,groups(j).type(i).Q,groups(j).type(i).lambda] = getStiffnessMatrix_Schur(FEM,groups(j));
    end
end